  
 MODULE mod_chem_spack_dratedc
  
   IMPLICIT NONE
   PRIVATE
   PUBLIC :: dratedc ! subroutine
 CONTAINS
  
   SUBROUTINE dratedc(rk,y,dw,ngas,ijkbeg,ijkend,maxblock_size,nr)
 
!------------------------------------------------------------------------
!
!     -- DESCRIPTION
!
!     This routine computes the derivative of reaction  rates.
!     This routine is automatically generated by SPACK.
!     Mechanism: ../Mechanism/RACM   
!     Species: ../Mechanism/ciRA77 
!
!------------------------------------------------------------------------
!
!     -- INPUT VARIABLES
!
!     RK: kinetic rates.
!     Y: chemical concentrations.
!
!     -- INPUT/OUTPUT VARIABLES
!
!     -- OUTPUT VARIABLES
!
!     DW: derivative of reaction rates wrt Y.
!
!------------------------------------------------------------------------
!
!     -- REMARKS
!
!------------------------------------------------------------------------
!
!     -- MODIFICATIONS
!
!------------------------------------------------------------------------
!
!     -- AUTHOR(S)
!
!     SPACK.
!
!------------------------------------------------------------------------
 
      IMPLICIT NONE
 
 
 
     INTEGER	       , INTENT(IN)  :: ngas                      
     INTEGER	       , INTENT(IN)  :: ijkbeg			  
     INTEGER	       , INTENT(IN)  :: ijkend			  
     INTEGER	       , INTENT(IN)  :: maxblock_size		  
     INTEGER	       , INTENT(IN)  :: nr			  
     DOUBLE PRECISION , INTENT(IN)  :: rk(maxblock_size,nr)	  
     DOUBLE PRECISION , INTENT(IN)  :: y(maxblock_size,NGAS) 	  
     DOUBLE PRECISION , INTENT(OUT) :: dw(maxblock_size,nr,NGAS) 
     INTEGER :: ijk						  
 
     DO ijk=ijkbeg,ijkend
  
  
      dw(ijk,  1,  4) =  rk(ijk,  1)
      dw(ijk,  2,  1) =  rk(ijk,  2)
      dw(ijk,  3,  1) =  rk(ijk,  3)
      dw(ijk,  4,  7) =  rk(ijk,  4)
      dw(ijk,  5,  8) =  rk(ijk,  5)
      dw(ijk,  6,  9) =  rk(ijk,  6)
      dw(ijk,  7,  5) =  rk(ijk,  7)
      dw(ijk,  8,  5) =  rk(ijk,  8)
      dw(ijk,  9,  2) =  rk(ijk,  9)
      dw(ijk, 10, 32) =  rk(ijk, 10)
      dw(ijk, 11, 32) =  rk(ijk, 11)
      dw(ijk, 12, 33) =  rk(ijk, 12)
      dw(ijk, 13, 44) =  rk(ijk, 13)
      dw(ijk, 14, 45) =  rk(ijk, 14)
      dw(ijk, 15, 46) =  rk(ijk, 15)
      dw(ijk, 16, 34) =  rk(ijk, 16)
      dw(ijk, 17, 35) =  rk(ijk, 17)
      dw(ijk, 18, 35) =  rk(ijk, 18)
      dw(ijk, 19, 36) =  rk(ijk, 19)
      dw(ijk, 20, 37) =  rk(ijk, 20)
      dw(ijk, 21, 41) =  rk(ijk, 21)
      dw(ijk, 22, 38) =  rk(ijk, 22)
      dw(ijk, 23, 40) =  rk(ijk, 23)
      dw(ijk, 24, 13) =  rk(ijk, 24)
      dw(ijk, 25, 13) =  rk(ijk, 25) * Y(ijk,  1)
      dw(ijk, 25,  1) =  rk(ijk, 25) * Y(ijk, 13)
      dw(ijk, 26, 14) =  rk(ijk, 26)
      dw(ijk, 27, 14) =  rk(ijk, 27)
      dw(ijk, 28, 14) =  rk(ijk, 28)
      dw(ijk, 29,  1) =  rk(ijk, 29) * Y(ijk, 15)
      dw(ijk, 29, 15) =  rk(ijk, 29) * Y(ijk,  1)
      dw(ijk, 30,  1) =  rk(ijk, 30) * Y(ijk, 16)
      dw(ijk, 30, 16) =  rk(ijk, 30) * Y(ijk,  1)
      dw(ijk, 31, 15) =  rk(ijk, 31) * Y(ijk, 16)
      dw(ijk, 31, 16) =  rk(ijk, 31) * Y(ijk, 15)
      dw(ijk, 32,  2) =  rk(ijk, 32) * Y(ijk, 15)
      dw(ijk, 32, 15) =  rk(ijk, 32) * Y(ijk,  2)
      dw(ijk, 33, 16) =  rk(ijk, 33) * Y(ijk, 16)
      dw(ijk, 33, 16) =  rk(ijk, 33) * Y(ijk, 16)
      dw(ijk, 34, 16) =  rk(ijk, 34) * Y(ijk, 16)
      dw(ijk, 34, 16) =  rk(ijk, 34) * Y(ijk, 16)
      dw(ijk, 35, 13) =  rk(ijk, 35) * Y(ijk,  3)
      dw(ijk, 35,  3) =  rk(ijk, 35) * Y(ijk, 13)
      dw(ijk, 36, 13) =  rk(ijk, 36) * Y(ijk,  4)
      dw(ijk, 36,  4) =  rk(ijk, 36) * Y(ijk, 13)
      dw(ijk, 37, 13) =  rk(ijk, 37) * Y(ijk,  4)
      dw(ijk, 37,  4) =  rk(ijk, 37) * Y(ijk, 13)
      dw(ijk, 38, 15) =  rk(ijk, 38) * Y(ijk,  3)
      dw(ijk, 38,  3) =  rk(ijk, 38) * Y(ijk, 15)
      dw(ijk, 39, 15) =  rk(ijk, 39) * Y(ijk,  4)
      dw(ijk, 39,  4) =  rk(ijk, 39) * Y(ijk, 15)
      dw(ijk, 40, 15) =  rk(ijk, 40) * Y(ijk,  5)
      dw(ijk, 40,  5) =  rk(ijk, 40) * Y(ijk, 15)
      dw(ijk, 41, 16) =  rk(ijk, 41) * Y(ijk,  3)
      dw(ijk, 41,  3) =  rk(ijk, 41) * Y(ijk, 16)
      dw(ijk, 42, 16) =  rk(ijk, 42) * Y(ijk,  4)
      dw(ijk, 42,  4) =  rk(ijk, 42) * Y(ijk, 16)
      dw(ijk, 43,  9) =  rk(ijk, 43)
      dw(ijk, 44, 16) =  rk(ijk, 44) * Y(ijk,  5)
      dw(ijk, 44,  5) =  rk(ijk, 44) * Y(ijk, 16)
      dw(ijk, 45, 15) =  rk(ijk, 45) * Y(ijk,  7)
      dw(ijk, 45,  7) =  rk(ijk, 45) * Y(ijk, 15)
      dw(ijk, 46, 15) =  rk(ijk, 46) * Y(ijk,  8)
      dw(ijk, 46,  8) =  rk(ijk, 46) * Y(ijk, 15)
      dw(ijk, 47, 15) =  rk(ijk, 47) * Y(ijk,  9)
      dw(ijk, 47,  9) =  rk(ijk, 47) * Y(ijk, 15)
      dw(ijk, 48,  1) =  rk(ijk, 48) * Y(ijk,  3)
      dw(ijk, 48,  3) =  rk(ijk, 48) * Y(ijk,  1)
      dw(ijk, 49,  1) =  rk(ijk, 49) * Y(ijk,  4)
      dw(ijk, 49,  4) =  rk(ijk, 49) * Y(ijk,  1)
      dw(ijk, 50,  3) =  rk(ijk, 50) * Y(ijk,  3)
      dw(ijk, 50,  3) =  rk(ijk, 50) * Y(ijk,  3)
      dw(ijk, 51,  5) =  rk(ijk, 51) * Y(ijk,  3)
      dw(ijk, 51,  3) =  rk(ijk, 51) * Y(ijk,  5)
      dw(ijk, 52,  5) =  rk(ijk, 52) * Y(ijk,  4)
      dw(ijk, 52,  4) =  rk(ijk, 52) * Y(ijk,  5)
      dw(ijk, 53,  5) =  rk(ijk, 53) * Y(ijk,  4)
      dw(ijk, 53,  4) =  rk(ijk, 53) * Y(ijk,  5)
      dw(ijk, 54,  6) =  rk(ijk, 54)
      dw(ijk, 55,  5) =  rk(ijk, 55) * Y(ijk,  5)
      dw(ijk, 55,  5) =  rk(ijk, 55) * Y(ijk,  5)
      dw(ijk, 56, 15) =  rk(ijk, 56)
      dw(ijk, 57, 15) =  rk(ijk, 57) * Y(ijk, 10)
      dw(ijk, 57, 10) =  rk(ijk, 57) * Y(ijk, 15)
      dw(ijk, 58, 12) =  rk(ijk, 58) * Y(ijk, 15)
      dw(ijk, 58, 15) =  rk(ijk, 58) * Y(ijk, 12)
      dw(ijk, 59, 26) =  rk(ijk, 59) * Y(ijk, 13)
      dw(ijk, 59, 13) =  rk(ijk, 59) * Y(ijk, 26)
      dw(ijk, 60, 38) =  rk(ijk, 60) * Y(ijk, 13)
      dw(ijk, 60, 13) =  rk(ijk, 60) * Y(ijk, 38)
      dw(ijk, 61, 17) =  rk(ijk, 61) * Y(ijk, 15)
      dw(ijk, 61, 15) =  rk(ijk, 61) * Y(ijk, 17)
      dw(ijk, 62, 18) =  rk(ijk, 62) * Y(ijk, 15)
      dw(ijk, 62, 15) =  rk(ijk, 62) * Y(ijk, 18)
      dw(ijk, 63, 19) =  rk(ijk, 63) * Y(ijk, 15)
      dw(ijk, 63, 15) =  rk(ijk, 63) * Y(ijk, 19)
      dw(ijk, 64, 20) =  rk(ijk, 64) * Y(ijk, 15)
      dw(ijk, 64, 15) =  rk(ijk, 64) * Y(ijk, 20)
      dw(ijk, 65, 21) =  rk(ijk, 65) * Y(ijk, 15)
      dw(ijk, 65, 15) =  rk(ijk, 65) * Y(ijk, 21)
      dw(ijk, 66, 22) =  rk(ijk, 66) * Y(ijk, 15)
      dw(ijk, 66, 15) =  rk(ijk, 66) * Y(ijk, 22)
      dw(ijk, 67, 23) =  rk(ijk, 67) * Y(ijk, 15)
      dw(ijk, 67, 15) =  rk(ijk, 67) * Y(ijk, 23)
      dw(ijk, 68, 24) =  rk(ijk, 68) * Y(ijk, 15)
      dw(ijk, 68, 15) =  rk(ijk, 68) * Y(ijk, 24)
      dw(ijk, 69, 25) =  rk(ijk, 69) * Y(ijk, 15)
      dw(ijk, 69, 15) =  rk(ijk, 69) * Y(ijk, 25)
      dw(ijk, 70, 26) =  rk(ijk, 70) * Y(ijk, 15)
      dw(ijk, 70, 15) =  rk(ijk, 70) * Y(ijk, 26)
      dw(ijk, 71, 27) =  rk(ijk, 71) * Y(ijk, 15)
      dw(ijk, 71, 15) =  rk(ijk, 71) * Y(ijk, 27)
      dw(ijk, 72, 28) =  rk(ijk, 72) * Y(ijk, 15)
      dw(ijk, 72, 15) =  rk(ijk, 72) * Y(ijk, 28)
      dw(ijk, 73, 29) =  rk(ijk, 73) * Y(ijk, 15)
      dw(ijk, 73, 15) =  rk(ijk, 73) * Y(ijk, 29)
      dw(ijk, 74, 30) =  rk(ijk, 74) * Y(ijk, 15)
      dw(ijk, 74, 15) =  rk(ijk, 74) * Y(ijk, 30)
      dw(ijk, 75, 31) =  rk(ijk, 75) * Y(ijk, 15)
      dw(ijk, 75, 15) =  rk(ijk, 75) * Y(ijk, 31)
      dw(ijk, 76, 32) =  rk(ijk, 76) * Y(ijk, 15)
      dw(ijk, 76, 15) =  rk(ijk, 76) * Y(ijk, 32)
      dw(ijk, 77, 33) =  rk(ijk, 77) * Y(ijk, 15)
      dw(ijk, 77, 15) =  rk(ijk, 77) * Y(ijk, 33)
      dw(ijk, 78, 34) =  rk(ijk, 78) * Y(ijk, 15)
      dw(ijk, 78, 15) =  rk(ijk, 78) * Y(ijk, 34)
      dw(ijk, 79, 40) =  rk(ijk, 79) * Y(ijk, 15)
      dw(ijk, 79, 15) =  rk(ijk, 79) * Y(ijk, 40)
      dw(ijk, 80, 35) =  rk(ijk, 80) * Y(ijk, 15)
      dw(ijk, 80, 15) =  rk(ijk, 80) * Y(ijk, 35)
      dw(ijk, 81, 36) =  rk(ijk, 81) * Y(ijk, 15)
      dw(ijk, 81, 15) =  rk(ijk, 81) * Y(ijk, 36)
      dw(ijk, 82, 38) =  rk(ijk, 82) * Y(ijk, 15)
      dw(ijk, 82, 15) =  rk(ijk, 82) * Y(ijk, 38)
      dw(ijk, 83, 15) =  rk(ijk, 83) * Y(ijk, 37)
      dw(ijk, 83, 37) =  rk(ijk, 83) * Y(ijk, 15)
      dw(ijk, 84, 15) =  rk(ijk, 84) * Y(ijk, 39)
      dw(ijk, 84, 39) =  rk(ijk, 84) * Y(ijk, 15)
      dw(ijk, 85, 44) =  rk(ijk, 85) * Y(ijk, 15)
      dw(ijk, 85, 15) =  rk(ijk, 85) * Y(ijk, 44)
      dw(ijk, 86, 45) =  rk(ijk, 86) * Y(ijk, 15)
      dw(ijk, 86, 15) =  rk(ijk, 86) * Y(ijk, 45)
      dw(ijk, 87, 46) =  rk(ijk, 87) * Y(ijk, 15)
      dw(ijk, 87, 15) =  rk(ijk, 87) * Y(ijk, 46)
      dw(ijk, 88, 42) =  rk(ijk, 88) * Y(ijk, 15)
      dw(ijk, 88, 15) =  rk(ijk, 88) * Y(ijk, 42)
      dw(ijk, 89, 43) =  rk(ijk, 89) * Y(ijk, 15)
      dw(ijk, 89, 15) =  rk(ijk, 89) * Y(ijk, 43)
      dw(ijk, 90, 41) =  rk(ijk, 90) * Y(ijk, 15)
      dw(ijk, 90, 15) =  rk(ijk, 90) * Y(ijk, 41)
      dw(ijk, 91, 32) =  rk(ijk, 91) * Y(ijk,  5)
      dw(ijk, 91,  5) =  rk(ijk, 91) * Y(ijk, 32)
      dw(ijk, 92, 33) =  rk(ijk, 92) * Y(ijk,  5)
      dw(ijk, 92,  5) =  rk(ijk, 92) * Y(ijk, 33)
      dw(ijk, 93, 35) =  rk(ijk, 93) * Y(ijk,  5)
      dw(ijk, 93,  5) =  rk(ijk, 93) * Y(ijk, 35)
      dw(ijk, 94, 36) =  rk(ijk, 94) * Y(ijk,  5)
      dw(ijk, 94,  5) =  rk(ijk, 94) * Y(ijk, 36)
      dw(ijk, 95, 38) =  rk(ijk, 95) * Y(ijk,  5)
      dw(ijk, 95,  5) =  rk(ijk, 95) * Y(ijk, 38)
      dw(ijk, 96, 37) =  rk(ijk, 96) * Y(ijk,  5)
      dw(ijk, 96,  5) =  rk(ijk, 96) * Y(ijk, 37)
      dw(ijk, 97, 31) =  rk(ijk, 97) * Y(ijk,  5)
      dw(ijk, 97,  5) =  rk(ijk, 97) * Y(ijk, 31)
      dw(ijk, 98, 22) =  rk(ijk, 98) * Y(ijk,  5)
      dw(ijk, 98,  5) =  rk(ijk, 98) * Y(ijk, 22)
      dw(ijk, 99, 23) =  rk(ijk, 99) * Y(ijk,  5)
      dw(ijk, 99,  5) =  rk(ijk, 99) * Y(ijk, 23)
      dw(ijk,100, 24) =  rk(ijk,100) * Y(ijk,  5)
      dw(ijk,100,  5) =  rk(ijk,100) * Y(ijk, 24)
      dw(ijk,101, 25) =  rk(ijk,101) * Y(ijk,  5)
      dw(ijk,101,  5) =  rk(ijk,101) * Y(ijk, 25)
      dw(ijk,102, 26) =  rk(ijk,102) * Y(ijk,  5)
      dw(ijk,102,  5) =  rk(ijk,102) * Y(ijk, 26)
      dw(ijk,103, 27) =  rk(ijk,103) * Y(ijk,  5)
      dw(ijk,103,  5) =  rk(ijk,103) * Y(ijk, 27)
      dw(ijk,104, 28) =  rk(ijk,104) * Y(ijk,  5)
      dw(ijk,104,  5) =  rk(ijk,104) * Y(ijk, 28)
      dw(ijk,105, 43) =  rk(ijk,105) * Y(ijk,  5)
      dw(ijk,105,  5) =  rk(ijk,105) * Y(ijk, 43)
      dw(ijk,106, 22) =  rk(ijk,106) * Y(ijk,  1)
      dw(ijk,106,  1) =  rk(ijk,106) * Y(ijk, 22)
      dw(ijk,107, 23) =  rk(ijk,107) * Y(ijk,  1)
      dw(ijk,107,  1) =  rk(ijk,107) * Y(ijk, 23)
      dw(ijk,108, 24) =  rk(ijk,108) * Y(ijk,  1)
      dw(ijk,108,  1) =  rk(ijk,108) * Y(ijk, 24)
      dw(ijk,109, 25) =  rk(ijk,109) * Y(ijk,  1)
      dw(ijk,109,  1) =  rk(ijk,109) * Y(ijk, 25)
      dw(ijk,110, 26) =  rk(ijk,110) * Y(ijk,  1)
      dw(ijk,110,  1) =  rk(ijk,110) * Y(ijk, 26)
      dw(ijk,111, 27) =  rk(ijk,111) * Y(ijk,  1)
      dw(ijk,111,  1) =  rk(ijk,111) * Y(ijk, 27)
      dw(ijk,112, 28) =  rk(ijk,112) * Y(ijk,  1)
      dw(ijk,112,  1) =  rk(ijk,112) * Y(ijk, 28)
      dw(ijk,113, 38) =  rk(ijk,113) * Y(ijk,  1)
      dw(ijk,113,  1) =  rk(ijk,113) * Y(ijk, 38)
      dw(ijk,114, 37) =  rk(ijk,114) * Y(ijk,  1)
      dw(ijk,114,  1) =  rk(ijk,114) * Y(ijk, 37)
      dw(ijk,115, 43) =  rk(ijk,115) * Y(ijk,  1)
      dw(ijk,115,  1) =  rk(ijk,115) * Y(ijk, 43)
      dw(ijk,116, 60) =  rk(ijk,116) * Y(ijk,  4)
      dw(ijk,116,  4) =  rk(ijk,116) * Y(ijk, 60)
      dw(ijk,117, 60) =  rk(ijk,117) * Y(ijk, 16)
      dw(ijk,117, 16) =  rk(ijk,117) * Y(ijk, 60)
      dw(ijk,118, 61) =  rk(ijk,118) * Y(ijk,  4)
      dw(ijk,118,  4) =  rk(ijk,118) * Y(ijk, 61)
      dw(ijk,119, 61) =  rk(ijk,119)
      dw(ijk,120, 61) =  rk(ijk,120) * Y(ijk,  1)
      dw(ijk,120,  1) =  rk(ijk,120) * Y(ijk, 61)
      dw(ijk,121, 62) =  rk(ijk,121) * Y(ijk,  4)
      dw(ijk,121,  4) =  rk(ijk,121) * Y(ijk, 62)
      dw(ijk,122, 62) =  rk(ijk,122)
      dw(ijk,123, 62) =  rk(ijk,123) * Y(ijk,  1)
      dw(ijk,123,  1) =  rk(ijk,123) * Y(ijk, 62)
      dw(ijk,124, 63) =  rk(ijk,124) * Y(ijk,  4)
      dw(ijk,124,  4) =  rk(ijk,124) * Y(ijk, 63)
      dw(ijk,125, 63) =  rk(ijk,125)
      dw(ijk,126, 63) =  rk(ijk,126) * Y(ijk,  1)
      dw(ijk,126,  1) =  rk(ijk,126) * Y(ijk, 63)
      dw(ijk,127, 67) =  rk(ijk,127) * Y(ijk,  4)
      dw(ijk,127,  4) =  rk(ijk,127) * Y(ijk, 67)
      dw(ijk,128, 42) =  rk(ijk,128)
      dw(ijk,129, 68) =  rk(ijk,129) * Y(ijk,  4)
      dw(ijk,129,  4) =  rk(ijk,129) * Y(ijk, 68)
      dw(ijk,130, 43) =  rk(ijk,130)
      dw(ijk,131, 49) =  rk(ijk,131) * Y(ijk,  3)
      dw(ijk,131,  3) =  rk(ijk,131) * Y(ijk, 49)
      dw(ijk,132, 50) =  rk(ijk,132) * Y(ijk,  3)
      dw(ijk,132,  3) =  rk(ijk,132) * Y(ijk, 50)
      dw(ijk,133, 51) =  rk(ijk,133) * Y(ijk,  3)
      dw(ijk,133,  3) =  rk(ijk,133) * Y(ijk, 51)
      dw(ijk,134, 52) =  rk(ijk,134) * Y(ijk,  3)
      dw(ijk,134,  3) =  rk(ijk,134) * Y(ijk, 52)
      dw(ijk,135, 53) =  rk(ijk,135) * Y(ijk,  3)
      dw(ijk,135,  3) =  rk(ijk,135) * Y(ijk, 53)
      dw(ijk,136, 54) =  rk(ijk,136) * Y(ijk,  3)
      dw(ijk,136,  3) =  rk(ijk,136) * Y(ijk, 54)
      dw(ijk,137, 55) =  rk(ijk,137) * Y(ijk,  3)
      dw(ijk,137,  3) =  rk(ijk,137) * Y(ijk, 55)
      dw(ijk,138, 56) =  rk(ijk,138) * Y(ijk,  3)
      dw(ijk,138,  3) =  rk(ijk,138) * Y(ijk, 56)
      dw(ijk,139, 57) =  rk(ijk,139) * Y(ijk,  3)
      dw(ijk,139,  3) =  rk(ijk,139) * Y(ijk, 57)
      dw(ijk,140, 58) =  rk(ijk,140) * Y(ijk,  3)
      dw(ijk,140,  3) =  rk(ijk,140) * Y(ijk, 58)
      dw(ijk,141, 59) =  rk(ijk,141) * Y(ijk,  3)
      dw(ijk,141,  3) =  rk(ijk,141) * Y(ijk, 59)
      dw(ijk,142, 64) =  rk(ijk,142) * Y(ijk,  3)
      dw(ijk,142,  3) =  rk(ijk,142) * Y(ijk, 64)
      dw(ijk,143, 65) =  rk(ijk,143) * Y(ijk,  3)
      dw(ijk,143,  3) =  rk(ijk,143) * Y(ijk, 65)
      dw(ijk,144, 66) =  rk(ijk,144) * Y(ijk,  3)
      dw(ijk,144,  3) =  rk(ijk,144) * Y(ijk, 66)
      dw(ijk,145, 67) =  rk(ijk,145) * Y(ijk,  3)
      dw(ijk,145,  3) =  rk(ijk,145) * Y(ijk, 67)
      dw(ijk,146, 68) =  rk(ijk,146) * Y(ijk,  3)
      dw(ijk,146,  3) =  rk(ijk,146) * Y(ijk, 68)
      dw(ijk,147, 69) =  rk(ijk,147) * Y(ijk,  3)
      dw(ijk,147,  3) =  rk(ijk,147) * Y(ijk, 69)
      dw(ijk,148, 70) =  rk(ijk,148) * Y(ijk,  3)
      dw(ijk,148,  3) =  rk(ijk,148) * Y(ijk, 70)
      dw(ijk,149, 71) =  rk(ijk,149) * Y(ijk,  3)
      dw(ijk,149,  3) =  rk(ijk,149) * Y(ijk, 71)
      dw(ijk,150, 49) =  rk(ijk,150) * Y(ijk, 16)
      dw(ijk,150, 16) =  rk(ijk,150) * Y(ijk, 49)
      dw(ijk,151, 50) =  rk(ijk,151) * Y(ijk, 16)
      dw(ijk,151, 16) =  rk(ijk,151) * Y(ijk, 50)
      dw(ijk,152, 51) =  rk(ijk,152) * Y(ijk, 16)
      dw(ijk,152, 16) =  rk(ijk,152) * Y(ijk, 51)
      dw(ijk,153, 52) =  rk(ijk,153) * Y(ijk, 16)
      dw(ijk,153, 16) =  rk(ijk,153) * Y(ijk, 52)
      dw(ijk,154, 53) =  rk(ijk,154) * Y(ijk, 16)
      dw(ijk,154, 16) =  rk(ijk,154) * Y(ijk, 53)
      dw(ijk,155, 54) =  rk(ijk,155) * Y(ijk, 16)
      dw(ijk,155, 16) =  rk(ijk,155) * Y(ijk, 54)
      dw(ijk,156, 55) =  rk(ijk,156) * Y(ijk, 16)
      dw(ijk,156, 16) =  rk(ijk,156) * Y(ijk, 55)
      dw(ijk,157, 56) =  rk(ijk,157) * Y(ijk, 16)
      dw(ijk,157, 16) =  rk(ijk,157) * Y(ijk, 56)
      dw(ijk,158, 57) =  rk(ijk,158) * Y(ijk, 16)
      dw(ijk,158, 16) =  rk(ijk,158) * Y(ijk, 57)
      dw(ijk,159, 58) =  rk(ijk,159) * Y(ijk, 16)
      dw(ijk,159, 16) =  rk(ijk,159) * Y(ijk, 58)
      dw(ijk,160, 59) =  rk(ijk,160) * Y(ijk, 16)
      dw(ijk,160, 16) =  rk(ijk,160) * Y(ijk, 59)
      dw(ijk,161, 64) =  rk(ijk,161) * Y(ijk, 16)
      dw(ijk,161, 16) =  rk(ijk,161) * Y(ijk, 64)
      dw(ijk,162, 65) =  rk(ijk,162) * Y(ijk, 16)
      dw(ijk,162, 16) =  rk(ijk,162) * Y(ijk, 65)
      dw(ijk,163, 66) =  rk(ijk,163) * Y(ijk, 16)
      dw(ijk,163, 16) =  rk(ijk,163) * Y(ijk, 66)
      dw(ijk,164, 67) =  rk(ijk,164) * Y(ijk, 16)
      dw(ijk,164, 16) =  rk(ijk,164) * Y(ijk, 67)
      dw(ijk,165, 67) =  rk(ijk,165) * Y(ijk, 16)
      dw(ijk,165, 16) =  rk(ijk,165) * Y(ijk, 67)
      dw(ijk,166, 68) =  rk(ijk,166) * Y(ijk, 16)
      dw(ijk,166, 16) =  rk(ijk,166) * Y(ijk, 68)
      dw(ijk,167, 68) =  rk(ijk,167) * Y(ijk, 16)
      dw(ijk,167, 16) =  rk(ijk,167) * Y(ijk, 68)
      dw(ijk,168, 69) =  rk(ijk,168) * Y(ijk, 16)
      dw(ijk,168, 16) =  rk(ijk,168) * Y(ijk, 69)
      dw(ijk,169, 70) =  rk(ijk,169) * Y(ijk, 16)
      dw(ijk,169, 16) =  rk(ijk,169) * Y(ijk, 70)
      dw(ijk,170, 71) =  rk(ijk,170) * Y(ijk, 16)
      dw(ijk,170, 16) =  rk(ijk,170) * Y(ijk, 71)
      dw(ijk,171, 49) =  rk(ijk,171) * Y(ijk, 49)
      dw(ijk,171, 49) =  rk(ijk,171) * Y(ijk, 49)
      dw(ijk,172, 50) =  rk(ijk,172) * Y(ijk, 49)
      dw(ijk,172, 49) =  rk(ijk,172) * Y(ijk, 50)
      dw(ijk,173, 51) =  rk(ijk,173) * Y(ijk, 49)
      dw(ijk,173, 49) =  rk(ijk,173) * Y(ijk, 51)
      dw(ijk,174, 52) =  rk(ijk,174) * Y(ijk, 49)
      dw(ijk,174, 49) =  rk(ijk,174) * Y(ijk, 52)
      dw(ijk,175, 53) =  rk(ijk,175) * Y(ijk, 49)
      dw(ijk,175, 49) =  rk(ijk,175) * Y(ijk, 53)
      dw(ijk,176, 54) =  rk(ijk,176) * Y(ijk, 49)
      dw(ijk,176, 49) =  rk(ijk,176) * Y(ijk, 54)
      dw(ijk,177, 55) =  rk(ijk,177) * Y(ijk, 49)
      dw(ijk,177, 49) =  rk(ijk,177) * Y(ijk, 55)
      dw(ijk,178, 56) =  rk(ijk,178) * Y(ijk, 49)
      dw(ijk,178, 49) =  rk(ijk,178) * Y(ijk, 56)
      dw(ijk,179, 57) =  rk(ijk,179) * Y(ijk, 49)
      dw(ijk,179, 49) =  rk(ijk,179) * Y(ijk, 57)
      dw(ijk,180, 58) =  rk(ijk,180) * Y(ijk, 49)
      dw(ijk,180, 49) =  rk(ijk,180) * Y(ijk, 58)
      dw(ijk,181, 59) =  rk(ijk,181) * Y(ijk, 49)
      dw(ijk,181, 49) =  rk(ijk,181) * Y(ijk, 59)
      dw(ijk,182, 64) =  rk(ijk,182) * Y(ijk, 49)
      dw(ijk,182, 49) =  rk(ijk,182) * Y(ijk, 64)
      dw(ijk,183, 65) =  rk(ijk,183) * Y(ijk, 49)
      dw(ijk,183, 49) =  rk(ijk,183) * Y(ijk, 65)
      dw(ijk,184, 66) =  rk(ijk,184) * Y(ijk, 49)
      dw(ijk,184, 49) =  rk(ijk,184) * Y(ijk, 66)
      dw(ijk,185, 67) =  rk(ijk,185) * Y(ijk, 49)
      dw(ijk,185, 49) =  rk(ijk,185) * Y(ijk, 67)
      dw(ijk,186, 67) =  rk(ijk,186) * Y(ijk, 49)
      dw(ijk,186, 49) =  rk(ijk,186) * Y(ijk, 67)
      dw(ijk,187, 68) =  rk(ijk,187) * Y(ijk, 49)
      dw(ijk,187, 49) =  rk(ijk,187) * Y(ijk, 68)
      dw(ijk,188, 68) =  rk(ijk,188) * Y(ijk, 49)
      dw(ijk,188, 49) =  rk(ijk,188) * Y(ijk, 68)
      dw(ijk,189, 69) =  rk(ijk,189) * Y(ijk, 49)
      dw(ijk,189, 49) =  rk(ijk,189) * Y(ijk, 69)
      dw(ijk,190, 70) =  rk(ijk,190) * Y(ijk, 49)
      dw(ijk,190, 49) =  rk(ijk,190) * Y(ijk, 70)
      dw(ijk,191, 71) =  rk(ijk,191) * Y(ijk, 49)
      dw(ijk,191, 49) =  rk(ijk,191) * Y(ijk, 71)
      dw(ijk,192, 50) =  rk(ijk,192) * Y(ijk, 67)
      dw(ijk,192, 67) =  rk(ijk,192) * Y(ijk, 50)
      dw(ijk,193, 51) =  rk(ijk,193) * Y(ijk, 67)
      dw(ijk,193, 67) =  rk(ijk,193) * Y(ijk, 51)
      dw(ijk,194, 52) =  rk(ijk,194) * Y(ijk, 67)
      dw(ijk,194, 67) =  rk(ijk,194) * Y(ijk, 52)
      dw(ijk,195, 53) =  rk(ijk,195) * Y(ijk, 67)
      dw(ijk,195, 67) =  rk(ijk,195) * Y(ijk, 53)
      dw(ijk,196, 54) =  rk(ijk,196) * Y(ijk, 67)
      dw(ijk,196, 67) =  rk(ijk,196) * Y(ijk, 54)
      dw(ijk,197, 55) =  rk(ijk,197) * Y(ijk, 67)
      dw(ijk,197, 67) =  rk(ijk,197) * Y(ijk, 55)
      dw(ijk,198, 56) =  rk(ijk,198) * Y(ijk, 67)
      dw(ijk,198, 67) =  rk(ijk,198) * Y(ijk, 56)
      dw(ijk,199, 57) =  rk(ijk,199) * Y(ijk, 67)
      dw(ijk,199, 67) =  rk(ijk,199) * Y(ijk, 57)
      dw(ijk,200, 58) =  rk(ijk,200) * Y(ijk, 67)
      dw(ijk,200, 67) =  rk(ijk,200) * Y(ijk, 58)
      dw(ijk,201, 59) =  rk(ijk,201) * Y(ijk, 67)
      dw(ijk,201, 67) =  rk(ijk,201) * Y(ijk, 59)
      dw(ijk,202, 64) =  rk(ijk,202) * Y(ijk, 67)
      dw(ijk,202, 67) =  rk(ijk,202) * Y(ijk, 64)
      dw(ijk,203, 65) =  rk(ijk,203) * Y(ijk, 67)
      dw(ijk,203, 67) =  rk(ijk,203) * Y(ijk, 65)
      dw(ijk,204, 66) =  rk(ijk,204) * Y(ijk, 67)
      dw(ijk,204, 67) =  rk(ijk,204) * Y(ijk, 66)
      dw(ijk,205, 67) =  rk(ijk,205) * Y(ijk, 67)
      dw(ijk,205, 67) =  rk(ijk,205) * Y(ijk, 67)
      dw(ijk,206, 68) =  rk(ijk,206) * Y(ijk, 67)
      dw(ijk,206, 67) =  rk(ijk,206) * Y(ijk, 68)
      dw(ijk,207, 69) =  rk(ijk,207) * Y(ijk, 67)
      dw(ijk,207, 67) =  rk(ijk,207) * Y(ijk, 69)
      dw(ijk,208, 70) =  rk(ijk,208) * Y(ijk, 67)
      dw(ijk,208, 67) =  rk(ijk,208) * Y(ijk, 70)
      dw(ijk,209, 71) =  rk(ijk,209) * Y(ijk, 67)
      dw(ijk,209, 67) =  rk(ijk,209) * Y(ijk, 71)
      dw(ijk,210, 70) =  rk(ijk,210) * Y(ijk, 70)
      dw(ijk,210, 70) =  rk(ijk,210) * Y(ijk, 70)
      dw(ijk,211, 70) =  rk(ijk,211) * Y(ijk, 71)
      dw(ijk,211, 71) =  rk(ijk,211) * Y(ijk, 70)
      dw(ijk,212, 71) =  rk(ijk,212) * Y(ijk, 71)
      dw(ijk,212, 71) =  rk(ijk,212) * Y(ijk, 71)
      dw(ijk,213, 49) =  rk(ijk,213) * Y(ijk,  5)
      dw(ijk,213,  5) =  rk(ijk,213) * Y(ijk, 49)
      dw(ijk,214, 50) =  rk(ijk,214) * Y(ijk,  5)
      dw(ijk,214,  5) =  rk(ijk,214) * Y(ijk, 50)
      dw(ijk,215, 51) =  rk(ijk,215) * Y(ijk,  5)
      dw(ijk,215,  5) =  rk(ijk,215) * Y(ijk, 51)
      dw(ijk,216, 52) =  rk(ijk,216) * Y(ijk,  5)
      dw(ijk,216,  5) =  rk(ijk,216) * Y(ijk, 52)
      dw(ijk,217, 53) =  rk(ijk,217) * Y(ijk,  5)
      dw(ijk,217,  5) =  rk(ijk,217) * Y(ijk, 53)
      dw(ijk,218, 54) =  rk(ijk,218) * Y(ijk,  5)
      dw(ijk,218,  5) =  rk(ijk,218) * Y(ijk, 54)
      dw(ijk,219, 55) =  rk(ijk,219) * Y(ijk,  5)
      dw(ijk,219,  5) =  rk(ijk,219) * Y(ijk, 55)
      dw(ijk,220, 56) =  rk(ijk,220) * Y(ijk,  5)
      dw(ijk,220,  5) =  rk(ijk,220) * Y(ijk, 56)
      dw(ijk,221, 57) =  rk(ijk,221) * Y(ijk,  5)
      dw(ijk,221,  5) =  rk(ijk,221) * Y(ijk, 57)
      dw(ijk,222, 58) =  rk(ijk,222) * Y(ijk,  5)
      dw(ijk,222,  5) =  rk(ijk,222) * Y(ijk, 58)
      dw(ijk,223, 59) =  rk(ijk,223) * Y(ijk,  5)
      dw(ijk,223,  5) =  rk(ijk,223) * Y(ijk, 59)
      dw(ijk,224, 64) =  rk(ijk,224) * Y(ijk,  5)
      dw(ijk,224,  5) =  rk(ijk,224) * Y(ijk, 64)
      dw(ijk,225, 65) =  rk(ijk,225) * Y(ijk,  5)
      dw(ijk,225,  5) =  rk(ijk,225) * Y(ijk, 65)
      dw(ijk,226, 66) =  rk(ijk,226) * Y(ijk,  5)
      dw(ijk,226,  5) =  rk(ijk,226) * Y(ijk, 66)
      dw(ijk,227, 67) =  rk(ijk,227) * Y(ijk,  5)
      dw(ijk,227,  5) =  rk(ijk,227) * Y(ijk, 67)
      dw(ijk,228, 68) =  rk(ijk,228) * Y(ijk,  5)
      dw(ijk,228,  5) =  rk(ijk,228) * Y(ijk, 68)
      dw(ijk,229, 69) =  rk(ijk,229) * Y(ijk,  5)
      dw(ijk,229,  5) =  rk(ijk,229) * Y(ijk, 69)
      dw(ijk,230, 70) =  rk(ijk,230) * Y(ijk,  5)
      dw(ijk,230,  5) =  rk(ijk,230) * Y(ijk, 70)
      dw(ijk,231, 71) =  rk(ijk,231) * Y(ijk,  5)
      dw(ijk,231,  5) =  rk(ijk,231) * Y(ijk, 71)
      dw(ijk,232, 72) =  rk(ijk,232) * Y(ijk, 16)
      dw(ijk,232, 16) =  rk(ijk,232) * Y(ijk, 72)
      dw(ijk,233, 72) =  rk(ijk,233) * Y(ijk, 49)
      dw(ijk,233, 49) =  rk(ijk,233) * Y(ijk, 72)
      dw(ijk,234, 72) =  rk(ijk,234) * Y(ijk, 67)
      dw(ijk,234, 67) =  rk(ijk,234) * Y(ijk, 72)
      dw(ijk,235, 72) =  rk(ijk,235) * Y(ijk, 72)
      dw(ijk,235, 72) =  rk(ijk,235) * Y(ijk, 72)
      dw(ijk,236, 72) =  rk(ijk,236) * Y(ijk,  3)
      dw(ijk,236,  3) =  rk(ijk,236) * Y(ijk, 72)
      dw(ijk,237, 72) =  rk(ijk,237) * Y(ijk,  5)
      dw(ijk,237,  5) =  rk(ijk,237) * Y(ijk, 72)
       END DO
 
   END SUBROUTINE dratedc
 
  END MODULE mod_chem_spack_dratedc
 
