                                                                                                                                                      
 MODULE mod_chem_spack_jacdchemdc                                                                                                                     
                                                                                                                                                      
   USE mod_chem_spack_dratedc, ONLY: dratedc  ! subroutine                                                                                            
   IMPLICIT NONE                                                                                                                                      
   PRIVATE                                                                                                                                            
   PUBLIC :: jacdchemdc ! subroutine                                                                                                                  
 CONTAINS                                                                                                                                             
                                                                                                                                                      
   SUBROUTINE jacdchemdc(y,rk,JacC,ngas,ijkbeg,ijkend,maxblock_size,nr)                                                                               
                                                                                                                                                      
!------------------------------------------------------------------------                                                                             
!                                                                                                                                                     
!     -- DESCRIPTION                                                                                                                                  
!                                                                                                                                                     
!     This routine computes the Jacobian matrix for the gas-phase.                                                                                    
!     This routine is automatically generated by SPACK.                                                                                               
!     Mechanism: ../Mechanism/RACM                                                                                                                    
!     Species: ../Mechanism/ciRA77                                                                                                                    
!                                                                                                                                                     
!------------------------------------------------------------------------                                                                             
!                                                                                                                                                     
!     -- INPUT VARIABLES                                                                                                                              
!                                                                                                                                                     
!     Y: chemical concentrations.                                                                                                                     
!     RK: kinetic rates.                                                                                                                              
!                                                                                                                                                     
!     -- INPUT/OUTPUT VARIABLES                                                                                                                       
!                                                                                                                                                     
!     -- OUTPUT VARIABLES                                                                                                                             
!                                                                                                                                                     
!     JACC: Jacobian matrix.                                                                                                                          
!                                                                                                                                                     
!------------------------------------------------------------------------                                                                             
!                                                                                                                                                     
!     -- REMARKS                                                                                                                                      
!                                                                                                                                                     
!     The matrix JACC could be stored in a low-dimensional vector.                                                                                    
!                                                                                                                                                     
!------------------------------------------------------------------------                                                                             
!                                                                                                                                                     
!     -- MODIFICATIONS                                                                                                                                
!                                                                                                                                                     
!------------------------------------------------------------------------                                                                             
!                                                                                                                                                     
!     -- AUTHOR(S)                                                                                                                                    
!                                                                                                                                                     
!     SPACK.                                                                                                                                          
!                                                                                                                                                     
!------------------------------------------------------------------------                                                                             
                                                                                                                                                      
      IMPLICIT NONE                                                                                                                                   
                                                                                                                                                      
                                                                                                                                                      
       INTEGER 	 , INTENT(IN)  :: ngas                                                                                                                
       INTEGER 	 , INTENT(IN)  :: ijkbeg			                                                                                                           
       INTEGER 	 , INTENT(IN)  :: ijkend			                                                                                                           
       INTEGER 	 , INTENT(IN)  :: maxblock_size 		                                                                                                    
       INTEGER 	 , INTENT(IN)  :: nr 				                                                                                                             
       DOUBLE PRECISION , INTENT(IN)  :: rk(maxblock_size,nr)		                                                                                       
       DOUBLE PRECISION , INTENT(IN)  :: y(maxblock_size,NGAS) 	                                                                                      
       DOUBLE PRECISION , INTENT(OUT) :: JacC(maxblock_size,NGAS,NGAS)                                                                                
       								                                                                                                                                       
       DOUBLE PRECISION :: dw(maxblock_size,nr,NGAS)			                                                                                               
       INTEGER :: ijk							                                                                                                                          
                                                                                                                                                      
                                                                                                                                                      
      CALL dratedc(rk,y,dw,ngas,ijkbeg,ijkend,maxblock_size,nr)                                                                                       
                                                                                                                                                      
      DO ijk=ijkbeg,ijkend                                                                                                                            
      JacC(ijk,  3,  4) =  + dw(ijk,  1,  4) &
                           + dw(ijk, 36,  4) &
                           + dw(ijk, 52,  4)
      JacC(ijk,  4,  4) =  - dw(ijk,  1,  4) &
                           - dw(ijk, 36,  4) &
                           - dw(ijk, 37,  4) &
                           - dw(ijk, 39,  4) &
                           - dw(ijk, 42,  4) &
                           - dw(ijk, 49,  4) &
                           - dw(ijk, 53,  4) &
                           - dw(ijk,116,  4) &
                           - dw(ijk,118,  4) &
                           - dw(ijk,121,  4) &
                           - dw(ijk,124,  4) &
                           - dw(ijk,127,  4) &
                           - dw(ijk,129,  4)
      JacC(ijk, 13,  4) =  + dw(ijk,  1,  4) &
                           - dw(ijk, 36,  4) &
                           - dw(ijk, 37,  4)
      JacC(ijk,  1,  1) =  - dw(ijk,  2,  1) &
                           - dw(ijk,  3,  1) &
                           - dw(ijk, 25,  1) &
                           - dw(ijk, 29,  1) &
                           - dw(ijk, 30,  1) &
                           - dw(ijk, 48,  1) &
                           - dw(ijk, 49,  1) &
                           - dw(ijk,106,  1) &
                           - dw(ijk,107,  1) &
                           - dw(ijk,108,  1) &
                           - dw(ijk,109,  1) &
                           - dw(ijk,110,  1) &
                           - dw(ijk,111,  1) &
                           - dw(ijk,112,  1) &
                           - dw(ijk,113,  1) &
                           - dw(ijk,114,  1) &
                           - dw(ijk,115,  1) &
                           - dw(ijk,120,  1) &
                           - dw(ijk,123,  1) &
                           - dw(ijk,126,  1)
      JacC(ijk, 14,  1) =  + dw(ijk,  2,  1)
      JacC(ijk, 13,  1) =  + dw(ijk,  3,  1) &
                           - dw(ijk, 25,  1) &
                          + 0.9000000000000000D-01*dw(ijk,109,  1) &
                          + 0.9000000000000000D-01*dw(ijk,110,  1)
      JacC(ijk,  3,  7) =  + dw(ijk,  4,  7)
      JacC(ijk,  7,  7) =  - dw(ijk,  4,  7) &
                           - dw(ijk, 45,  7)
      JacC(ijk, 15,  7) =  + dw(ijk,  4,  7) &
                           - dw(ijk, 45,  7)
      JacC(ijk,  4,  8) =  + dw(ijk,  5,  8)
      JacC(ijk,  8,  8) =  - dw(ijk,  5,  8) &
                           - dw(ijk, 46,  8)
      JacC(ijk, 15,  8) =  + dw(ijk,  5,  8) &
                           - dw(ijk, 46,  8)
      JacC(ijk,  4,  9) = + 0.6500000000000000D+00*dw(ijk,  6,  9) &
                           + dw(ijk, 43,  9) &
                           + dw(ijk, 47,  9)
      JacC(ijk,  5,  9) = + 0.3500000000000000D+00*dw(ijk,  6,  9)
      JacC(ijk,  9,  9) =  - dw(ijk,  6,  9) &
                           - dw(ijk, 43,  9) &
                           - dw(ijk, 47,  9)
      JacC(ijk, 15,  9) = + 0.3500000000000000D+00*dw(ijk,  6,  9) &
                           - dw(ijk, 47,  9)
      JacC(ijk, 16,  9) = + 0.6500000000000000D+00*dw(ijk,  6,  9) &
                           + dw(ijk, 43,  9)
      JacC(ijk,  3,  5) =  + dw(ijk,  7,  5) &
                           - dw(ijk, 51,  5) &
                           + dw(ijk, 52,  5)
      JacC(ijk,  5,  5) =  - dw(ijk,  7,  5) &
                           - dw(ijk,  8,  5) &
                           - dw(ijk, 40,  5) &
                           - dw(ijk, 44,  5) &
                           - dw(ijk, 51,  5) &
                           - dw(ijk, 52,  5) &
                           - dw(ijk, 53,  5) &
                          - 0.2000000000000000D+01*dw(ijk, 55,  5) &
                          - 0.2000000000000000D+01*dw(ijk, 55,  5) &
                           - dw(ijk, 91,  5) &
                           - dw(ijk, 92,  5) &
                           - dw(ijk, 93,  5) &
                           - dw(ijk, 94,  5) &
                           - dw(ijk, 95,  5) &
                           - dw(ijk, 96,  5) &
                           - dw(ijk, 97,  5) &
                           - dw(ijk, 98,  5) &
                           - dw(ijk, 99,  5) &
                           - dw(ijk,100,  5) &
                           - dw(ijk,101,  5) &
                           - dw(ijk,102,  5) &
                           - dw(ijk,103,  5) &
                           - dw(ijk,104,  5) &
                          - 0.4000000000000000D+00*dw(ijk,105,  5) &
                           - dw(ijk,213,  5) &
                           - dw(ijk,214,  5) &
                           - dw(ijk,215,  5) &
                           - dw(ijk,216,  5) &
                           - dw(ijk,217,  5) &
                           - dw(ijk,218,  5) &
                           - dw(ijk,219,  5) &
                           - dw(ijk,220,  5) &
                           - dw(ijk,221,  5) &
                           - dw(ijk,222,  5) &
                           - dw(ijk,223,  5) &
                           - dw(ijk,224,  5) &
                           - dw(ijk,225,  5) &
                           - dw(ijk,226,  5) &
                           - dw(ijk,227,  5) &
                           - dw(ijk,228,  5) &
                           - dw(ijk,229,  5) &
                           - dw(ijk,230,  5) &
                           - dw(ijk,231,  5) &
                           - dw(ijk,237,  5)
      JacC(ijk,  4,  5) =  + dw(ijk,  8,  5) &
                           + dw(ijk, 40,  5) &
                          + 0.7000000000000000D+00*dw(ijk, 44,  5) &
                          + 0.2000000000000000D+01*dw(ijk, 51,  5) &
                           - dw(ijk, 53,  5) &
                          + 0.2000000000000000D+01*dw(ijk, 55,  5) &
                          + 0.2000000000000000D+01*dw(ijk, 55,  5) &
                          + 0.5000000000000000D+00*dw(ijk, 96,  5) &
                          + 0.4000000000000000D+00*dw(ijk,105,  5) &
                           + dw(ijk,213,  5) &
                           + dw(ijk,214,  5) &
                           + dw(ijk,215,  5) &
                           + dw(ijk,216,  5) &
                           + dw(ijk,217,  5) &
                           + dw(ijk,218,  5) &
                           + dw(ijk,219,  5) &
                           + dw(ijk,220,  5) &
                           + dw(ijk,221,  5) &
                           + dw(ijk,222,  5) &
                           + dw(ijk,223,  5) &
                           + dw(ijk,224,  5) &
                           + dw(ijk,225,  5) &
                           + dw(ijk,226,  5) &
                           + dw(ijk,227,  5) &
                           + dw(ijk,228,  5) &
                           + dw(ijk,229,  5) &
                           + dw(ijk,230,  5) &
                          + 0.2000000000000000D+01*dw(ijk,231,  5) &
                           + dw(ijk,237,  5)
      JacC(ijk, 13,  5) =  + dw(ijk,  8,  5)
      JacC(ijk,  2,  2) =  - dw(ijk,  9,  2) &
                           - dw(ijk, 32,  2)
      JacC(ijk, 15,  2) = + 0.2000000000000000D+01*dw(ijk,  9,  2) &
                           - dw(ijk, 32,  2)
      JacC(ijk, 12, 32) =  + dw(ijk, 10, 32) &
                           + dw(ijk, 11, 32) &
                           + dw(ijk, 76, 32) &
                           + dw(ijk, 91, 32)
      JacC(ijk, 32, 32) =  - dw(ijk, 10, 32) &
                           - dw(ijk, 11, 32) &
                           - dw(ijk, 76, 32) &
                           - dw(ijk, 91, 32)
      JacC(ijk, 16, 32) = + 0.2000000000000000D+01*dw(ijk, 11, 32) &
                           + dw(ijk, 76, 32) &
                           + dw(ijk, 91, 32)
      JacC(ijk, 12, 33) =  + dw(ijk, 12, 33)
      JacC(ijk, 16, 33) =  + dw(ijk, 12, 33)
      JacC(ijk, 33, 33) =  - dw(ijk, 12, 33) &
                           - dw(ijk, 77, 33) &
                           - dw(ijk, 92, 33)
      JacC(ijk, 49, 33) =  + dw(ijk, 12, 33)
      JacC(ijk, 15, 44) =  + dw(ijk, 13, 44) &
                          - 0.6500000000000000D+00*dw(ijk, 85, 44)
      JacC(ijk, 16, 44) =  + dw(ijk, 13, 44)
      JacC(ijk, 32, 44) =  + dw(ijk, 13, 44) &
                          + 0.3500000000000000D+00*dw(ijk, 85, 44)
      JacC(ijk, 44, 44) =  - dw(ijk, 13, 44) &
                           - dw(ijk, 85, 44)
      JacC(ijk, 15, 45) =  + dw(ijk, 14, 45) &
                          - 0.5100000000000000D+00*dw(ijk, 86, 45)
      JacC(ijk, 16, 45) =  + dw(ijk, 14, 45)
      JacC(ijk, 33, 45) =  + dw(ijk, 14, 45) &
                          + 0.8000000000000000D-01*dw(ijk, 86, 45)
      JacC(ijk, 45, 45) =  - dw(ijk, 14, 45) &
                           - dw(ijk, 86, 45)
      JacC(ijk, 15, 46) =  + dw(ijk, 15, 46) &
                           - dw(ijk, 87, 46)
      JacC(ijk, 46, 46) =  - dw(ijk, 15, 46) &
                           - dw(ijk, 87, 46)
      JacC(ijk, 49, 46) =  + dw(ijk, 15, 46)
      JacC(ijk, 34, 34) =  - dw(ijk, 16, 34) &
                           - dw(ijk, 78, 34)
      JacC(ijk, 50, 34) =  + dw(ijk, 16, 34)
      JacC(ijk, 67, 34) =  + dw(ijk, 16, 34)
      JacC(ijk, 12, 35) = + 0.1870000000000000D+01*dw(ijk, 17, 35) &
                          + 0.1550000000000000D+01*dw(ijk, 18, 35) &
                          + 0.2000000000000000D+01*dw(ijk, 80, 35) &
                          + 0.2000000000000000D+01*dw(ijk, 93, 35)
      JacC(ijk, 32, 35) = + 0.1300000000000000D+00*dw(ijk, 17, 35) &
                          + 0.4500000000000000D+00*dw(ijk, 18, 35)
      JacC(ijk, 35, 35) =  - dw(ijk, 17, 35) &
                           - dw(ijk, 18, 35) &
                           - dw(ijk, 80, 35) &
                           - dw(ijk, 93, 35)
      JacC(ijk, 16, 35) = + 0.8000000000000000D+00*dw(ijk, 18, 35) &
                           + dw(ijk, 80, 35) &
                           + dw(ijk, 93, 35)
      JacC(ijk, 12, 36) =  + dw(ijk, 19, 36) &
                           + dw(ijk, 81, 36) &
                           + dw(ijk, 94, 36)
      JacC(ijk, 16, 36) =  + dw(ijk, 19, 36)
      JacC(ijk, 36, 36) =  - dw(ijk, 19, 36) &
                           - dw(ijk, 81, 36) &
                           - dw(ijk, 94, 36)
      JacC(ijk, 67, 36) =  + dw(ijk, 19, 36) &
                           + dw(ijk, 81, 36) &
                           + dw(ijk, 94, 36)
      JacC(ijk, 16, 37) =  + dw(ijk, 20, 37) &
                          + 0.5000000000000000D+00*dw(ijk, 83, 37) &
                          + 0.5000000000000000D+00*dw(ijk, 96, 37) &
                          + 0.2900000000000000D+00*dw(ijk,114, 37)
      JacC(ijk, 37, 37) =  - dw(ijk, 20, 37) &
                           - dw(ijk, 83, 37) &
                           - dw(ijk, 96, 37) &
                           - dw(ijk,114, 37)
      JacC(ijk, 68, 37) =  + dw(ijk, 20, 37) &
                          + 0.5000000000000000D+00*dw(ijk, 83, 37) &
                          + 0.5000000000000000D+00*dw(ijk, 96, 37)
      JacC(ijk,  4, 41) =  + dw(ijk, 21, 41) &
                           + dw(ijk, 90, 41)
      JacC(ijk, 16, 41) =  + dw(ijk, 21, 41)
      JacC(ijk, 33, 41) = + 0.2000000000000000D+00*dw(ijk, 21, 41)
      JacC(ijk, 34, 41) = + 0.8000000000000000D+00*dw(ijk, 21, 41)
      JacC(ijk, 41, 41) =  - dw(ijk, 21, 41) &
                           - dw(ijk, 90, 41)
      JacC(ijk, 12, 38) =  + dw(ijk, 22, 38) &
                          + 0.4100000000000000D+00*dw(ijk, 82, 38) &
                          + 0.8000000000000000D+00*dw(ijk, 95, 38) &
                          + 0.5400000000000000D+00*dw(ijk,113, 38)
      JacC(ijk, 16, 38) =  + dw(ijk, 22, 38) &
                          + 0.4900000000000000D+00*dw(ijk, 82, 38) &
                          + 0.2900000000000000D+00*dw(ijk,113, 38)
      JacC(ijk, 32, 38) =  + dw(ijk, 22, 38) &
                          + 0.8000000000000000D-01*dw(ijk, 82, 38) &
                          + 0.4000000000000000D+00*dw(ijk,113, 38)
      JacC(ijk, 38, 38) =  - dw(ijk, 22, 38) &
                           - dw(ijk, 60, 38) &
                           - dw(ijk, 82, 38) &
                           - dw(ijk, 95, 38) &
                           - dw(ijk,113, 38)
      JacC(ijk, 67, 38) =  + dw(ijk, 22, 38) &
                          + 0.1300000000000000D+00*dw(ijk,113, 38)
      JacC(ijk, 16, 40) =  + dw(ijk, 23, 40) &
                           + dw(ijk, 79, 40)
      JacC(ijk, 32, 40) =  + dw(ijk, 23, 40)
      JacC(ijk, 40, 40) =  - dw(ijk, 23, 40) &
                           - dw(ijk, 79, 40)
      JacC(ijk, 67, 40) =  + dw(ijk, 23, 40)
      JacC(ijk,  1, 13) =  + dw(ijk, 24, 13) &
                           - dw(ijk, 25, 13)
      JacC(ijk, 13, 13) =  - dw(ijk, 24, 13) &
                           - dw(ijk, 25, 13) &
                           - dw(ijk, 35, 13) &
                           - dw(ijk, 36, 13) &
                           - dw(ijk, 37, 13) &
                           - dw(ijk, 59, 13) &
                           - dw(ijk, 60, 13)
      JacC(ijk, 13, 14) =  + dw(ijk, 26, 14) &
                           + dw(ijk, 27, 14)
      JacC(ijk, 14, 14) =  - dw(ijk, 26, 14) &
                           - dw(ijk, 27, 14) &
                           - dw(ijk, 28, 14)
      JacC(ijk, 15, 14) = + 0.2000000000000000D+01*dw(ijk, 28, 14)
      JacC(ijk,  1, 15) =  - dw(ijk, 29, 15)
      JacC(ijk, 15,  1) =  - dw(ijk, 29,  1) &
                           + dw(ijk, 30,  1) &
                          + 0.1200000000000000D+00*dw(ijk,106,  1) &
                          + 0.4000000000000000D+00*dw(ijk,107,  1) &
                          + 0.6300000000000000D+00*dw(ijk,108,  1) &
                          + 0.2800000000000000D+00*dw(ijk,109,  1) &
                          + 0.2800000000000000D+00*dw(ijk,110,  1) &
                          + 0.8500000000000000D+00*dw(ijk,111,  1) &
                          + 0.8500000000000000D+00*dw(ijk,112,  1) &
                          + 0.7000000000000001D-01*dw(ijk,113,  1) &
                          + 0.2100000000000000D+00*dw(ijk,114,  1) &
                          + 0.3600000000000000D-01*dw(ijk,115,  1) &
                           + dw(ijk,120,  1) &
                           + dw(ijk,123,  1) &
                           + dw(ijk,126,  1)
      JacC(ijk, 15, 15) =  - dw(ijk, 29, 15) &
                           - dw(ijk, 31, 15) &
                           - dw(ijk, 32, 15) &
                           - dw(ijk, 38, 15) &
                           - dw(ijk, 39, 15) &
                           - dw(ijk, 40, 15) &
                           - dw(ijk, 45, 15) &
                           - dw(ijk, 46, 15) &
                           - dw(ijk, 47, 15) &
                           - dw(ijk, 56, 15) &
                           - dw(ijk, 57, 15) &
                           - dw(ijk, 58, 15) &
                           - dw(ijk, 61, 15) &
                           - dw(ijk, 62, 15) &
                          - 0.9640000000000000D+00*dw(ijk, 63, 15) &
                           - dw(ijk, 64, 15) &
                           - dw(ijk, 65, 15) &
                           - dw(ijk, 66, 15) &
                           - dw(ijk, 67, 15) &
                           - dw(ijk, 68, 15) &
                           - dw(ijk, 69, 15) &
                           - dw(ijk, 70, 15) &
                           - dw(ijk, 71, 15) &
                           - dw(ijk, 72, 15) &
                           - dw(ijk, 73, 15) &
                           - dw(ijk, 74, 15) &
                           - dw(ijk, 75, 15) &
                           - dw(ijk, 76, 15) &
                           - dw(ijk, 77, 15) &
                           - dw(ijk, 78, 15) &
                           - dw(ijk, 79, 15) &
                           - dw(ijk, 80, 15) &
                           - dw(ijk, 81, 15) &
                           - dw(ijk, 82, 15) &
                           - dw(ijk, 83, 15) &
                           - dw(ijk, 84, 15) &
                          - 0.6500000000000000D+00*dw(ijk, 85, 15) &
                          - 0.5100000000000000D+00*dw(ijk, 86, 15) &
                           - dw(ijk, 87, 15) &
                           - dw(ijk, 88, 15) &
                           - dw(ijk, 89, 15) &
                           - dw(ijk, 90, 15)
      JacC(ijk, 16,  1) =  + dw(ijk, 29,  1) &
                           - dw(ijk, 30,  1) &
                          + 0.2600000000000000D+00*dw(ijk,106,  1) &
                          + 0.2500000000000000D+00*dw(ijk,107,  1) &
                          + 0.2200000000000000D+00*dw(ijk,108,  1) &
                          + 0.3000000000000000D+00*dw(ijk,109,  1) &
                          + 0.3000000000000000D+00*dw(ijk,110,  1) &
                          + 0.1000000000000000D+00*dw(ijk,111,  1) &
                          + 0.1000000000000000D+00*dw(ijk,112,  1) &
                          + 0.2900000000000000D+00*dw(ijk,113,  1) &
                          + 0.2900000000000000D+00*dw(ijk,114,  1) &
                          + 0.8000000000000000D-01*dw(ijk,115,  1)
      JacC(ijk, 16, 15) =  + dw(ijk, 29, 15) &
                           - dw(ijk, 31, 15) &
                           + dw(ijk, 32, 15) &
                           + dw(ijk, 40, 15) &
                           + dw(ijk, 56, 15) &
                           + dw(ijk, 57, 15) &
                           + dw(ijk, 58, 15) &
                          + 0.3810000000000000D+00*dw(ijk, 63, 15) &
                          + 0.2500000000000000D+00*dw(ijk, 64, 15) &
                          + 0.4900000000000000D-01*dw(ijk, 65, 15) &
                          + 0.1000000000000000D+00*dw(ijk, 73, 15) &
                          + 0.1000000000000000D+00*dw(ijk, 74, 15) &
                          + 0.5000000000000000D-01*dw(ijk, 75, 15) &
                           + dw(ijk, 76, 15) &
                           + dw(ijk, 79, 15) &
                           + dw(ijk, 80, 15) &
                          + 0.4900000000000000D+00*dw(ijk, 82, 15) &
                          + 0.5000000000000000D+00*dw(ijk, 83, 15) &
                           + dw(ijk, 84, 15) &
                          + 0.3500000000000000D+00*dw(ijk, 87, 15) &
                          + 0.4000000000000000D+00*dw(ijk, 89, 15)
      JacC(ijk,  1, 16) =  - dw(ijk, 30, 16) &
                           + dw(ijk,165, 16) &
                           + dw(ijk,167, 16)
      JacC(ijk, 15, 16) =  + dw(ijk, 30, 16) &
                           - dw(ijk, 31, 16) &
                           + dw(ijk, 41, 16) &
                          + 0.7000000000000000D+00*dw(ijk, 44, 16)
      JacC(ijk, 16, 16) =  - dw(ijk, 30, 16) &
                           - dw(ijk, 31, 16) &
                          - 0.2000000000000000D+01*dw(ijk, 33, 16) &
                          - 0.2000000000000000D+01*dw(ijk, 33, 16) &
                          - 0.2000000000000000D+01*dw(ijk, 34, 16) &
                          - 0.2000000000000000D+01*dw(ijk, 34, 16) &
                           - dw(ijk, 41, 16) &
                           - dw(ijk, 42, 16) &
                           - dw(ijk, 44, 16) &
                           - dw(ijk,117, 16) &
                           - dw(ijk,150, 16) &
                           - dw(ijk,151, 16) &
                           - dw(ijk,152, 16) &
                           - dw(ijk,153, 16) &
                           - dw(ijk,154, 16) &
                           - dw(ijk,155, 16) &
                           - dw(ijk,156, 16) &
                           - dw(ijk,157, 16) &
                           - dw(ijk,158, 16) &
                           - dw(ijk,159, 16) &
                           - dw(ijk,160, 16) &
                           - dw(ijk,161, 16) &
                           - dw(ijk,162, 16) &
                           - dw(ijk,163, 16) &
                           - dw(ijk,164, 16) &
                           - dw(ijk,165, 16) &
                           - dw(ijk,166, 16) &
                           - dw(ijk,167, 16) &
                           - dw(ijk,168, 16) &
                           - dw(ijk,169, 16) &
                           - dw(ijk,170, 16) &
                           - dw(ijk,232, 16)
      JacC(ijk,  2, 15) =  - dw(ijk, 32, 15)
      JacC(ijk, 16,  2) =  + dw(ijk, 32,  2)
      JacC(ijk,  2, 16) =  + dw(ijk, 33, 16) &
                           + dw(ijk, 33, 16) &
                           + dw(ijk, 34, 16) &
                           + dw(ijk, 34, 16)
      JacC(ijk,  3, 13) =  - dw(ijk, 35, 13) &
                           + dw(ijk, 36, 13)
      JacC(ijk,  3,  3) =  - dw(ijk, 35,  3) &
                           - dw(ijk, 38,  3) &
                           - dw(ijk, 41,  3) &
                           - dw(ijk, 48,  3) &
                          - 0.2000000000000000D+01*dw(ijk, 50,  3) &
                          - 0.2000000000000000D+01*dw(ijk, 50,  3) &
                           - dw(ijk, 51,  3) &
                           - dw(ijk,131,  3) &
                           - dw(ijk,132,  3) &
                           - dw(ijk,133,  3) &
                           - dw(ijk,134,  3) &
                           - dw(ijk,135,  3) &
                           - dw(ijk,136,  3) &
                           - dw(ijk,137,  3) &
                           - dw(ijk,138,  3) &
                           - dw(ijk,139,  3) &
                           - dw(ijk,140,  3) &
                           - dw(ijk,141,  3) &
                           - dw(ijk,142,  3) &
                           - dw(ijk,143,  3) &
                           - dw(ijk,144,  3) &
                           - dw(ijk,145,  3) &
                           - dw(ijk,146,  3) &
                           - dw(ijk,147,  3) &
                           - dw(ijk,148,  3) &
                           - dw(ijk,149,  3) &
                           - dw(ijk,236,  3)
      JacC(ijk,  4, 13) =  + dw(ijk, 35, 13) &
                           - dw(ijk, 36, 13) &
                           - dw(ijk, 37, 13)
      JacC(ijk,  4,  3) =  + dw(ijk, 35,  3) &
                           + dw(ijk, 41,  3) &
                           + dw(ijk, 48,  3) &
                          + 0.2000000000000000D+01*dw(ijk, 50,  3) &
                          + 0.2000000000000000D+01*dw(ijk, 50,  3) &
                          + 0.2000000000000000D+01*dw(ijk, 51,  3) &
                           + dw(ijk,131,  3) &
                           + dw(ijk,132,  3) &
                          + 0.9409999999999999D+00*dw(ijk,133,  3) &
                          + 0.8760000000000000D+00*dw(ijk,134,  3) &
                          + 0.7390000000000000D+00*dw(ijk,135,  3) &
                           + dw(ijk,136,  3) &
                           + dw(ijk,137,  3) &
                           + dw(ijk,138,  3) &
                          + 0.8470000000000000D+00*dw(ijk,139,  3) &
                          + 0.8000000000000000D+00*dw(ijk,140,  3) &
                          + 0.6500000000000000D+00*dw(ijk,141,  3) &
                          + 0.9500000000000000D+00*dw(ijk,142,  3) &
                          + 0.9500000000000000D+00*dw(ijk,143,  3) &
                           + dw(ijk,144,  3) &
                           + dw(ijk,145,  3) &
                           + dw(ijk,146,  3) &
                           + dw(ijk,147,  3) &
                           + dw(ijk,148,  3) &
                          + 0.2000000000000000D+01*dw(ijk,149,  3) &
                           + dw(ijk,236,  3)
      JacC(ijk, 13,  3) =  - dw(ijk, 35,  3)
      JacC(ijk,  5, 13) =  + dw(ijk, 37, 13)
      JacC(ijk,  5,  4) =  + dw(ijk, 37,  4) &
                           + dw(ijk, 49,  4) &
                           - dw(ijk, 52,  4) &
                           - dw(ijk, 53,  4)
      JacC(ijk,  3, 15) =  - dw(ijk, 38, 15)
      JacC(ijk,  7, 15) =  + dw(ijk, 38, 15) &
                           - dw(ijk, 45, 15)
      JacC(ijk,  7,  3) =  + dw(ijk, 38,  3)
      JacC(ijk, 15,  3) =  - dw(ijk, 38,  3) &
                           + dw(ijk, 41,  3)
      JacC(ijk,  4, 15) =  - dw(ijk, 39, 15) &
                           + dw(ijk, 40, 15) &
                           + dw(ijk, 45, 15) &
                           + dw(ijk, 47, 15) &
                           + dw(ijk, 90, 15)
      JacC(ijk,  8, 15) =  + dw(ijk, 39, 15) &
                           - dw(ijk, 46, 15)
      JacC(ijk,  8,  4) =  + dw(ijk, 39,  4)
      JacC(ijk, 15,  4) =  - dw(ijk, 39,  4)
      JacC(ijk,  5, 15) =  - dw(ijk, 40, 15) &
                           + dw(ijk, 46, 15) &
                           + dw(ijk, 88, 15) &
                          + 0.6000000000000000D+00*dw(ijk, 89, 15)
      JacC(ijk, 15,  5) =  - dw(ijk, 40,  5) &
                          + 0.7000000000000000D+00*dw(ijk, 44,  5)
      JacC(ijk, 16,  5) =  + dw(ijk, 40,  5) &
                           - dw(ijk, 44,  5) &
                           + dw(ijk, 91,  5) &
                           + dw(ijk, 93,  5) &
                          + 0.5000000000000000D+00*dw(ijk, 96,  5) &
                           + dw(ijk,213,  5) &
                           + dw(ijk,214,  5) &
                          + 0.7920000000000000D+00*dw(ijk,215,  5) &
                          + 0.6990000000000000D+00*dw(ijk,216,  5) &
                          + 0.8450000000000000D+00*dw(ijk,217,  5) &
                           + dw(ijk,218,  5) &
                           + dw(ijk,219,  5) &
                           + dw(ijk,220,  5) &
                           + dw(ijk,221,  5) &
                           + dw(ijk,222,  5) &
                           + dw(ijk,223,  5) &
                           + dw(ijk,224,  5) &
                           + dw(ijk,225,  5) &
                           + dw(ijk,226,  5) &
                          + 0.7700000000000000D+00*dw(ijk,229,  5) &
                           + dw(ijk,230,  5)
      JacC(ijk,  3, 16) =  - dw(ijk, 41, 16)
      JacC(ijk,  4, 16) =  + dw(ijk, 41, 16) &
                           - dw(ijk, 42, 16) &
                          + 0.7000000000000000D+00*dw(ijk, 44, 16)
      JacC(ijk, 16,  3) =  - dw(ijk, 41,  3) &
                           + dw(ijk,131,  3) &
                           + dw(ijk,132,  3) &
                          + 0.7420000000000000D+00*dw(ijk,133,  3) &
                          + 0.5990000000000000D+00*dw(ijk,134,  3) &
                          + 0.6060000000000000D+00*dw(ijk,135,  3) &
                           + dw(ijk,136,  3) &
                           + dw(ijk,137,  3) &
                           + dw(ijk,138,  3) &
                          + 0.8470000000000000D+00*dw(ijk,139,  3) &
                          + 0.8000000000000000D+00*dw(ijk,140,  3) &
                          + 0.6500000000000000D+00*dw(ijk,141,  3) &
                          + 0.9500000000000000D+00*dw(ijk,142,  3) &
                          + 0.9500000000000000D+00*dw(ijk,143,  3) &
                           + dw(ijk,144,  3) &
                          + 0.7700000000000000D+00*dw(ijk,147,  3) &
                           + dw(ijk,148,  3)
      JacC(ijk,  9, 16) =  + dw(ijk, 42, 16)
      JacC(ijk,  9,  4) =  + dw(ijk, 42,  4)
      JacC(ijk, 16,  4) =  - dw(ijk, 42,  4)
      JacC(ijk,  5, 16) =  - dw(ijk, 44, 16)
      JacC(ijk,  8, 16) = + 0.3000000000000000D+00*dw(ijk, 44, 16)
      JacC(ijk,  8,  5) = + 0.3000000000000000D+00*dw(ijk, 44,  5) &
                           + dw(ijk, 91,  5) &
                           + dw(ijk, 92,  5) &
                           + dw(ijk, 93,  5) &
                           + dw(ijk, 94,  5) &
                          + 0.2000000000000000D+00*dw(ijk, 95,  5) &
                          + 0.5000000000000000D+00*dw(ijk, 96,  5) &
                           + dw(ijk, 97,  5)
      JacC(ijk,  4,  7) =  + dw(ijk, 45,  7)
      JacC(ijk,  5,  8) =  + dw(ijk, 46,  8)
      JacC(ijk,  9, 15) =  - dw(ijk, 47, 15)
      JacC(ijk,  1,  3) =  - dw(ijk, 48,  3)
      JacC(ijk,  3,  1) =  - dw(ijk, 48,  1)
      JacC(ijk,  4,  1) =  + dw(ijk, 48,  1) &
                           - dw(ijk, 49,  1) &
                          + 0.7000000000000000D+00*dw(ijk,115,  1)
      JacC(ijk,  1,  4) =  - dw(ijk, 49,  4)
      JacC(ijk,  5,  1) =  + dw(ijk, 49,  1)
      JacC(ijk,  5,  3) =  - dw(ijk, 51,  3)
      JacC(ijk,  6,  5) =  + dw(ijk, 53,  5)
      JacC(ijk,  6,  4) =  + dw(ijk, 53,  4)
      JacC(ijk,  4,  6) =  + dw(ijk, 54,  6)
      JacC(ijk,  5,  6) =  + dw(ijk, 54,  6)
      JacC(ijk,  6,  6) =  - dw(ijk, 54,  6)
      JacC(ijk, 10, 15) =  - dw(ijk, 57, 15)
      JacC(ijk, 10, 10) =  - dw(ijk, 57, 10)
      JacC(ijk, 11, 15) =  + dw(ijk, 57, 15)
      JacC(ijk, 11, 10) =  + dw(ijk, 57, 10)
      JacC(ijk, 15, 10) =  - dw(ijk, 57, 10)
      JacC(ijk, 16, 10) =  + dw(ijk, 57, 10)
      JacC(ijk, 12, 12) =  - dw(ijk, 58, 12)
      JacC(ijk, 12, 15) =  - dw(ijk, 58, 15) &
                          + 0.3600000000000000D-01*dw(ijk, 63, 15) &
                           + dw(ijk, 76, 15) &
                          + 0.2000000000000000D+01*dw(ijk, 80, 15) &
                           + dw(ijk, 81, 15) &
                          + 0.4100000000000000D+00*dw(ijk, 82, 15)
      JacC(ijk, 15, 12) =  - dw(ijk, 58, 12)
      JacC(ijk, 16, 12) =  + dw(ijk, 58, 12)
      JacC(ijk, 12, 26) = + 0.1000000000000000D-01*dw(ijk, 59, 26) &
                          + 0.3600000000000000D+00*dw(ijk,110, 26)
      JacC(ijk, 12, 13) = + 0.1000000000000000D-01*dw(ijk, 59, 13)
      JacC(ijk, 13, 26) =  - dw(ijk, 59, 26) &
                          + 0.9000000000000000D-01*dw(ijk,110, 26)
      JacC(ijk, 15, 26) = + 0.2000000000000000D-01*dw(ijk, 59, 26) &
                           - dw(ijk, 70, 26) &
                          + 0.2800000000000000D+00*dw(ijk,110, 26)
      JacC(ijk, 15, 13) = + 0.2000000000000000D-01*dw(ijk, 59, 13)
      JacC(ijk, 16, 26) = + 0.2800000000000000D+00*dw(ijk, 59, 26) &
                          + 0.3000000000000000D+00*dw(ijk,110, 26)
      JacC(ijk, 16, 13) = + 0.2800000000000000D+00*dw(ijk, 59, 13)
      JacC(ijk, 23, 26) = + 0.8600000000000000D+00*dw(ijk, 59, 26) &
                          + 0.3500000000000000D+00*dw(ijk,110, 26)
      JacC(ijk, 23, 13) = + 0.8600000000000000D+00*dw(ijk, 59, 13)
      JacC(ijk, 26, 26) =  - dw(ijk, 59, 26) &
                           - dw(ijk, 70, 26) &
                           - dw(ijk,102, 26) &
                           - dw(ijk,110, 26)
      JacC(ijk, 26, 13) =  - dw(ijk, 59, 13)
      JacC(ijk, 32, 26) = + 0.5000000000000000D-01*dw(ijk, 59, 26) &
                          + 0.9000000000000000D+00*dw(ijk,110, 26)
      JacC(ijk, 32, 13) = + 0.5000000000000000D-01*dw(ijk, 59, 13)
      JacC(ijk, 37, 26) = + 0.1300000000000000D+00*dw(ijk, 59, 26)
      JacC(ijk, 37, 13) = + 0.1300000000000000D+00*dw(ijk, 59, 13)
      JacC(ijk, 72, 26) = + 0.1500000000000000D+00*dw(ijk, 59, 26) &
                          + 0.1300000000000000D+00*dw(ijk,110, 26)
      JacC(ijk, 72, 13) = + 0.1500000000000000D+00*dw(ijk, 59, 13)
      JacC(ijk, 13, 38) =  - dw(ijk, 60, 38)
      JacC(ijk, 33, 38) =  + dw(ijk, 60, 38)
      JacC(ijk, 33, 13) =  + dw(ijk, 60, 13)
      JacC(ijk, 38, 13) =  - dw(ijk, 60, 13)
      JacC(ijk, 15, 17) =  - dw(ijk, 61, 17)
      JacC(ijk, 17, 17) =  - dw(ijk, 61, 17)
      JacC(ijk, 17, 15) =  - dw(ijk, 61, 15)
      JacC(ijk, 49, 17) =  + dw(ijk, 61, 17)
      JacC(ijk, 49, 15) =  + dw(ijk, 61, 15) &
                          + 0.6500000000000000D+00*dw(ijk, 85, 15)
      JacC(ijk, 15, 18) =  - dw(ijk, 62, 18)
      JacC(ijk, 18, 18) =  - dw(ijk, 62, 18)
      JacC(ijk, 18, 15) =  - dw(ijk, 62, 15)
      JacC(ijk, 50, 18) =  + dw(ijk, 62, 18)
      JacC(ijk, 50, 15) =  + dw(ijk, 62, 15)
      JacC(ijk, 12, 19) = + 0.3600000000000000D-01*dw(ijk, 63, 19)
      JacC(ijk, 15, 19) = - 0.9640000000000000D+00*dw(ijk, 63, 19)
      JacC(ijk, 16, 19) = + 0.3810000000000000D+00*dw(ijk, 63, 19)
      JacC(ijk, 19, 19) =  - dw(ijk, 63, 19)
      JacC(ijk, 19, 15) =  - dw(ijk, 63, 15)
      JacC(ijk, 32, 19) = + 0.1000000000000000D-01*dw(ijk, 63, 19)
      JacC(ijk, 32, 15) = + 0.1000000000000000D-01*dw(ijk, 63, 15) &
                           - dw(ijk, 76, 15) &
                          + 0.8000000000000000D-01*dw(ijk, 82, 15) &
                          + 0.3500000000000000D+00*dw(ijk, 85, 15) &
                          + 0.3500000000000000D+00*dw(ijk, 87, 15) &
                           + dw(ijk, 88, 15) &
                          + 0.4000000000000000D+00*dw(ijk, 89, 15)
      JacC(ijk, 33, 19) = + 0.3350000000000000D+00*dw(ijk, 63, 19)
      JacC(ijk, 33, 15) = + 0.3350000000000000D+00*dw(ijk, 63, 15) &
                          + 0.2500000000000000D-01*dw(ijk, 65, 15) &
                           - dw(ijk, 77, 15) &
                          + 0.8800000000000000D+00*dw(ijk, 84, 15) &
                          + 0.8000000000000000D-01*dw(ijk, 86, 15)
      JacC(ijk, 35, 19) = + 0.3600000000000000D-01*dw(ijk, 63, 19)
      JacC(ijk, 35, 15) = + 0.3600000000000000D-01*dw(ijk, 63, 15) &
                           - dw(ijk, 80, 15) &
                          + 0.1500000000000000D+00*dw(ijk, 83, 15)
      JacC(ijk, 47, 19) = + 0.3600000000000000D-01*dw(ijk, 63, 19)
      JacC(ijk, 47, 15) = + 0.3600000000000000D-01*dw(ijk, 63, 15)
      JacC(ijk, 51, 19) = + 0.5830000000000000D+00*dw(ijk, 63, 19)
      JacC(ijk, 51, 15) = + 0.5830000000000000D+00*dw(ijk, 63, 15) &
                          + 0.4400000000000000D+00*dw(ijk, 86, 15) &
                           + dw(ijk, 90, 15)
      JacC(ijk, 15, 20) =  - dw(ijk, 64, 20)
      JacC(ijk, 16, 20) = + 0.2500000000000000D+00*dw(ijk, 64, 20)
      JacC(ijk, 20, 20) =  - dw(ijk, 64, 20)
      JacC(ijk, 20, 15) =  - dw(ijk, 64, 15)
      JacC(ijk, 34, 20) = + 0.2500000000000000D+00*dw(ijk, 64, 20)
      JacC(ijk, 34, 15) = + 0.2500000000000000D+00*dw(ijk, 64, 15) &
                           - dw(ijk, 78, 15) &
                          + 0.1200000000000000D+00*dw(ijk, 84, 15) &
                          + 0.4100000000000000D+00*dw(ijk, 86, 15)
      JacC(ijk, 52, 20) = + 0.7500000000000000D+00*dw(ijk, 64, 20)
      JacC(ijk, 52, 15) = + 0.7500000000000000D+00*dw(ijk, 64, 15)
      JacC(ijk, 15, 21) =  - dw(ijk, 65, 21)
      JacC(ijk, 16, 21) = + 0.4900000000000000D-01*dw(ijk, 65, 21)
      JacC(ijk, 21, 21) =  - dw(ijk, 65, 21)
      JacC(ijk, 21, 15) =  - dw(ijk, 65, 15)
      JacC(ijk, 33, 21) = + 0.2500000000000000D-01*dw(ijk, 65, 21)
      JacC(ijk, 40, 21) = + 0.2400000000000000D-01*dw(ijk, 65, 21)
      JacC(ijk, 40, 15) = + 0.2400000000000000D-01*dw(ijk, 65, 15) &
                           - dw(ijk, 79, 15) &
                          + 0.4100000000000000D+00*dw(ijk, 82, 15) &
                          + 0.6000000000000000D+00*dw(ijk, 89, 15)
      JacC(ijk, 53, 21) = + 0.9510000000000000D+00*dw(ijk, 65, 21)
      JacC(ijk, 53, 15) = + 0.9510000000000000D+00*dw(ijk, 65, 15)
      JacC(ijk, 15, 22) =  - dw(ijk, 66, 22) &
                          + 0.1200000000000000D+00*dw(ijk,106, 22)
      JacC(ijk, 22, 22) =  - dw(ijk, 66, 22) &
                           - dw(ijk, 98, 22) &
                           - dw(ijk,106, 22)
      JacC(ijk, 22, 15) =  - dw(ijk, 66, 15)
      JacC(ijk, 54, 22) =  + dw(ijk, 66, 22)
      JacC(ijk, 54, 15) =  + dw(ijk, 66, 15)
      JacC(ijk, 15, 23) =  - dw(ijk, 67, 23) &
                          + 0.4000000000000000D+00*dw(ijk,107, 23)
      JacC(ijk, 23, 23) =  - dw(ijk, 67, 23) &
                           - dw(ijk, 99, 23) &
                           - dw(ijk,107, 23)
      JacC(ijk, 23, 15) =  - dw(ijk, 67, 15)
      JacC(ijk, 55, 23) =  + dw(ijk, 67, 23)
      JacC(ijk, 55, 15) =  + dw(ijk, 67, 15)
      JacC(ijk, 15, 24) =  - dw(ijk, 68, 24) &
                          + 0.6300000000000000D+00*dw(ijk,108, 24)
      JacC(ijk, 24, 24) =  - dw(ijk, 68, 24) &
                           - dw(ijk,100, 24) &
                           - dw(ijk,108, 24)
      JacC(ijk, 24, 15) =  - dw(ijk, 68, 15)
      JacC(ijk, 56, 24) =  + dw(ijk, 68, 24)
      JacC(ijk, 56, 15) =  + dw(ijk, 68, 15)
      JacC(ijk, 15, 25) =  - dw(ijk, 69, 25) &
                          + 0.2800000000000000D+00*dw(ijk,109, 25)
      JacC(ijk, 25, 25) =  - dw(ijk, 69, 25) &
                           - dw(ijk,101, 25) &
                           - dw(ijk,109, 25)
      JacC(ijk, 25, 15) =  - dw(ijk, 69, 15)
      JacC(ijk, 57, 25) =  + dw(ijk, 69, 25)
      JacC(ijk, 57, 15) =  + dw(ijk, 69, 15) &
                           + dw(ijk, 70, 15)
      JacC(ijk, 26, 15) =  - dw(ijk, 70, 15)
      JacC(ijk, 57, 26) =  + dw(ijk, 70, 26)
      JacC(ijk, 15, 27) =  - dw(ijk, 71, 27) &
                          + 0.8500000000000000D+00*dw(ijk,111, 27)
      JacC(ijk, 27, 27) =  - dw(ijk, 71, 27) &
                           - dw(ijk,103, 27) &
                           - dw(ijk,111, 27)
      JacC(ijk, 27, 15) =  - dw(ijk, 71, 15)
      JacC(ijk, 58, 27) =  + dw(ijk, 71, 27)
      JacC(ijk, 58, 15) =  + dw(ijk, 71, 15)
      JacC(ijk, 15, 28) =  - dw(ijk, 72, 28) &
                          + 0.8500000000000000D+00*dw(ijk,112, 28)
      JacC(ijk, 28, 28) =  - dw(ijk, 72, 28) &
                           - dw(ijk,104, 28) &
                           - dw(ijk,112, 28)
      JacC(ijk, 28, 15) =  - dw(ijk, 72, 15)
      JacC(ijk, 59, 28) =  + dw(ijk, 72, 28)
      JacC(ijk, 59, 15) =  + dw(ijk, 72, 15)
      JacC(ijk, 15, 29) =  - dw(ijk, 73, 29)
      JacC(ijk, 16, 29) = + 0.1000000000000000D+00*dw(ijk, 73, 29)
      JacC(ijk, 29, 29) =  - dw(ijk, 73, 29)
      JacC(ijk, 29, 15) =  - dw(ijk, 73, 15)
      JacC(ijk, 61, 29) = + 0.9000000000000000D+00*dw(ijk, 73, 29)
      JacC(ijk, 61, 15) = + 0.9000000000000000D+00*dw(ijk, 73, 15)
      JacC(ijk, 72, 29) = + 0.1000000000000000D+00*dw(ijk, 73, 29)
      JacC(ijk, 72, 15) = + 0.1000000000000000D+00*dw(ijk, 73, 15) &
                          + 0.1000000000000000D+00*dw(ijk, 74, 15) &
                          + 0.5000000000000000D-01*dw(ijk, 75, 15) &
                          + 0.4900000000000000D+00*dw(ijk, 82, 15) &
                          + 0.5000000000000000D+00*dw(ijk, 83, 15) &
                          + 0.7000000000000001D-01*dw(ijk, 86, 15) &
                          + 0.3500000000000000D+00*dw(ijk, 87, 15) &
                           + dw(ijk, 88, 15) &
                           + dw(ijk, 89, 15)
      JacC(ijk, 15, 30) =  - dw(ijk, 74, 30)
      JacC(ijk, 16, 30) = + 0.1000000000000000D+00*dw(ijk, 74, 30)
      JacC(ijk, 30, 30) =  - dw(ijk, 74, 30)
      JacC(ijk, 30, 15) =  - dw(ijk, 74, 15)
      JacC(ijk, 62, 30) = + 0.9000000000000000D+00*dw(ijk, 74, 30)
      JacC(ijk, 62, 15) = + 0.9000000000000000D+00*dw(ijk, 74, 15)
      JacC(ijk, 72, 30) = + 0.1000000000000000D+00*dw(ijk, 74, 30)
      JacC(ijk, 15, 31) =  - dw(ijk, 75, 31)
      JacC(ijk, 16, 31) = + 0.5000000000000000D-01*dw(ijk, 75, 31)
      JacC(ijk, 31, 31) =  - dw(ijk, 75, 31) &
                           - dw(ijk, 97, 31)
      JacC(ijk, 31, 15) =  - dw(ijk, 75, 15)
      JacC(ijk, 60, 31) = + 0.1000000000000000D+00*dw(ijk, 75, 31) &
                           + dw(ijk, 97, 31)
      JacC(ijk, 60, 15) = + 0.1000000000000000D+00*dw(ijk, 75, 15)
      JacC(ijk, 63, 31) = + 0.8500000000000000D+00*dw(ijk, 75, 31)
      JacC(ijk, 63, 15) = + 0.8500000000000000D+00*dw(ijk, 75, 15)
      JacC(ijk, 72, 31) = + 0.5000000000000000D-01*dw(ijk, 75, 31)
      JacC(ijk, 15, 32) =  - dw(ijk, 76, 32)
      JacC(ijk, 15, 33) =  - dw(ijk, 77, 33)
      JacC(ijk, 67, 33) =  + dw(ijk, 77, 33) &
                           + dw(ijk, 92, 33)
      JacC(ijk, 67, 15) =  + dw(ijk, 77, 15) &
                           + dw(ijk, 81, 15) &
                          + 0.6500000000000000D+00*dw(ijk, 87, 15)
      JacC(ijk, 15, 34) =  - dw(ijk, 78, 34)
      JacC(ijk, 69, 34) =  + dw(ijk, 78, 34)
      JacC(ijk, 69, 15) =  + dw(ijk, 78, 15)
      JacC(ijk, 15, 40) =  - dw(ijk, 79, 40)
      JacC(ijk, 36, 40) =  + dw(ijk, 79, 40)
      JacC(ijk, 36, 15) =  + dw(ijk, 79, 15) &
                           - dw(ijk, 81, 15) &
                          + 0.8000000000000000D-01*dw(ijk, 82, 15) &
                          + 0.1500000000000000D+00*dw(ijk, 83, 15)
      JacC(ijk, 15, 35) =  - dw(ijk, 80, 35)
      JacC(ijk, 15, 36) =  - dw(ijk, 81, 36)
      JacC(ijk, 15, 38) =  - dw(ijk, 82, 38) &
                          + 0.7000000000000001D-01*dw(ijk,113, 38)
      JacC(ijk, 36, 38) = + 0.8000000000000000D-01*dw(ijk, 82, 38) &
                          + 0.6000000000000000D+00*dw(ijk,113, 38)
      JacC(ijk, 38, 15) =  - dw(ijk, 82, 15)
      JacC(ijk, 40, 38) = + 0.4100000000000000D+00*dw(ijk, 82, 38)
      JacC(ijk, 68, 38) = + 0.5100000000000000D+00*dw(ijk, 82, 38) &
                          + 0.2000000000000000D+00*dw(ijk, 95, 38)
      JacC(ijk, 68, 15) = + 0.5100000000000000D+00*dw(ijk, 82, 15) &
                          + 0.5000000000000000D+00*dw(ijk, 83, 15)
      JacC(ijk, 72, 38) = + 0.4900000000000000D+00*dw(ijk, 82, 38)
      JacC(ijk, 15, 37) =  - dw(ijk, 83, 37) &
                          + 0.2100000000000000D+00*dw(ijk,114, 37)
      JacC(ijk, 35, 37) = + 0.1500000000000000D+00*dw(ijk, 83, 37) &
                          + 0.2500000000000000D+00*dw(ijk, 96, 37) &
                          + 0.5000000000000000D+00*dw(ijk,114, 37)
      JacC(ijk, 36, 37) = + 0.1500000000000000D+00*dw(ijk, 83, 37) &
                          + 0.2500000000000000D+00*dw(ijk, 96, 37) &
                          + 0.6200000000000000D+00*dw(ijk,114, 37)
      JacC(ijk, 37, 15) =  - dw(ijk, 83, 15)
      JacC(ijk, 39, 15) = + 0.3500000000000000D+00*dw(ijk, 83, 15) &
                           - dw(ijk, 84, 15)
      JacC(ijk, 39, 37) = + 0.3500000000000000D+00*dw(ijk, 83, 37)
      JacC(ijk, 72, 37) = + 0.5000000000000000D+00*dw(ijk, 83, 37) &
                          + 0.5000000000000000D+00*dw(ijk, 96, 37)
      JacC(ijk, 15, 39) =  - dw(ijk, 84, 39)
      JacC(ijk, 16, 39) =  + dw(ijk, 84, 39)
      JacC(ijk, 33, 39) = + 0.8800000000000000D+00*dw(ijk, 84, 39)
      JacC(ijk, 34, 39) = + 0.1200000000000000D+00*dw(ijk, 84, 39)
      JacC(ijk, 39, 39) =  - dw(ijk, 84, 39)
      JacC(ijk, 44, 15) =  - dw(ijk, 85, 15)
      JacC(ijk, 49, 44) = + 0.6500000000000000D+00*dw(ijk, 85, 44)
      JacC(ijk, 34, 45) = + 0.4100000000000000D+00*dw(ijk, 86, 45)
      JacC(ijk, 45, 15) =  - dw(ijk, 86, 15)
      JacC(ijk, 51, 45) = + 0.4400000000000000D+00*dw(ijk, 86, 45)
      JacC(ijk, 72, 45) = + 0.7000000000000001D-01*dw(ijk, 86, 45)
      JacC(ijk, 16, 46) = + 0.3500000000000000D+00*dw(ijk, 87, 46)
      JacC(ijk, 32, 46) = + 0.3500000000000000D+00*dw(ijk, 87, 46)
      JacC(ijk, 46, 15) =  - dw(ijk, 87, 15)
      JacC(ijk, 67, 46) = + 0.6500000000000000D+00*dw(ijk, 87, 46)
      JacC(ijk, 72, 46) = + 0.3500000000000000D+00*dw(ijk, 87, 46)
      JacC(ijk,  5, 42) =  + dw(ijk, 88, 42)
      JacC(ijk, 15, 42) =  - dw(ijk, 88, 42)
      JacC(ijk, 32, 42) =  + dw(ijk, 88, 42)
      JacC(ijk, 42, 42) =  - dw(ijk, 88, 42) &
                           - dw(ijk,128, 42)
      JacC(ijk, 42, 15) =  - dw(ijk, 88, 15) &
                          + 0.4000000000000000D+00*dw(ijk, 89, 15)
      JacC(ijk, 72, 42) =  + dw(ijk, 88, 42)
      JacC(ijk,  5, 43) = + 0.6000000000000000D+00*dw(ijk, 89, 43) &
                          - 0.4000000000000000D+00*dw(ijk,105, 43)
      JacC(ijk, 15, 43) =  - dw(ijk, 89, 43) &
                          + 0.3600000000000000D-01*dw(ijk,115, 43)
      JacC(ijk, 16, 43) = + 0.4000000000000000D+00*dw(ijk, 89, 43) &
                          + 0.8000000000000000D-01*dw(ijk,115, 43)
      JacC(ijk, 32, 43) = + 0.4000000000000000D+00*dw(ijk, 89, 43) &
                          + 0.4000000000000000D+00*dw(ijk,105, 43) &
                          + 0.7000000000000000D+00*dw(ijk,115, 43)
      JacC(ijk, 40, 43) = + 0.6000000000000000D+00*dw(ijk, 89, 43)
      JacC(ijk, 42, 43) = + 0.4000000000000000D+00*dw(ijk, 89, 43) &
                          + 0.4000000000000000D+00*dw(ijk,105, 43) &
                          + 0.3000000000000000D+00*dw(ijk,115, 43)
      JacC(ijk, 43, 43) =  - dw(ijk, 89, 43) &
                           - dw(ijk,105, 43) &
                           - dw(ijk,115, 43) &
                           - dw(ijk,130, 43)
      JacC(ijk, 43, 15) =  - dw(ijk, 89, 15)
      JacC(ijk, 72, 43) =  + dw(ijk, 89, 43) &
                           + dw(ijk,105, 43)
      JacC(ijk, 15, 41) =  - dw(ijk, 90, 41)
      JacC(ijk, 41, 15) =  - dw(ijk, 90, 15)
      JacC(ijk, 51, 41) =  + dw(ijk, 90, 41)
      JacC(ijk,  5, 32) =  - dw(ijk, 91, 32)
      JacC(ijk,  8, 32) =  + dw(ijk, 91, 32)
      JacC(ijk, 12,  5) =  + dw(ijk, 91,  5) &
                          + 0.2000000000000000D+01*dw(ijk, 93,  5) &
                           + dw(ijk, 94,  5) &
                          + 0.8000000000000000D+00*dw(ijk, 95,  5)
      JacC(ijk, 32,  5) =  - dw(ijk, 91,  5) &
                          + 0.4000000000000000D+00*dw(ijk,105,  5) &
                           + dw(ijk,213,  5) &
                          + 0.4800000000000000D-01*dw(ijk,215,  5) &
                          + 0.2100000000000000D-01*dw(ijk,216,  5) &
                          + 0.1600000000000000D+01*dw(ijk,218,  5) &
                           + dw(ijk,219,  5) &
                          + 0.6860000000000001D+00*dw(ijk,221,  5) &
                          + 0.4000000000000000D+00*dw(ijk,223,  5) &
                           + dw(ijk,228,  5) &
                          + 0.2800000000000000D+00*dw(ijk,231,  5)
      JacC(ijk,  5, 33) =  - dw(ijk, 92, 33)
      JacC(ijk,  8, 33) =  + dw(ijk, 92, 33)
      JacC(ijk, 33,  5) =  - dw(ijk, 92,  5) &
                          + 0.2500000000000000D+00*dw(ijk, 96,  5) &
                           + dw(ijk,214,  5) &
                          + 0.2430000000000000D+00*dw(ijk,215,  5) &
                          + 0.2390000000000000D+00*dw(ijk,216,  5) &
                          + 0.1870000000000000D+00*dw(ijk,217,  5) &
                          + 0.2000000000000000D+00*dw(ijk,218,  5) &
                          + 0.9399999999999999D+00*dw(ijk,219,  5) &
                          + 0.1710000000000000D+01*dw(ijk,220,  5) &
                           + dw(ijk,222,  5) &
                          + 0.4600000000000000D+00*dw(ijk,229,  5) &
                          + 0.1240000000000000D+01*dw(ijk,231,  5)
      JacC(ijk, 67,  5) =  + dw(ijk, 92,  5) &
                           + dw(ijk, 94,  5) &
                           - dw(ijk,227,  5) &
                           + dw(ijk,228,  5) &
                          + 0.2300000000000000D+00*dw(ijk,229,  5)
      JacC(ijk,  5, 35) =  - dw(ijk, 93, 35)
      JacC(ijk,  8, 35) =  + dw(ijk, 93, 35)
      JacC(ijk, 35,  5) =  - dw(ijk, 93,  5) &
                          + 0.2500000000000000D+00*dw(ijk, 96,  5) &
                          + 0.6300000000000000D-01*dw(ijk,215,  5) &
                          + 0.1300000000000000D+01*dw(ijk,224,  5) &
                          + 0.7400000000000000D+00*dw(ijk,225,  5) &
                           + dw(ijk,226,  5)
      JacC(ijk,  5, 36) =  - dw(ijk, 94, 36)
      JacC(ijk,  8, 36) =  + dw(ijk, 94, 36)
      JacC(ijk, 36,  5) =  - dw(ijk, 94,  5) &
                          + 0.2500000000000000D+00*dw(ijk, 96,  5) &
                          + 0.7000000000000000D+00*dw(ijk,224,  5) &
                          + 0.1260000000000000D+01*dw(ijk,225,  5) &
                           + dw(ijk,226,  5) &
                          + 0.5400000000000000D+00*dw(ijk,229,  5)
      JacC(ijk,  5, 38) =  - dw(ijk, 95, 38)
      JacC(ijk,  8, 38) = + 0.2000000000000000D+00*dw(ijk, 95, 38)
      JacC(ijk, 38,  5) =  - dw(ijk, 95,  5) &
                          + 0.9000000000000000D+00*dw(ijk,101,  5) &
                          + 0.9000000000000000D+00*dw(ijk,102,  5) &
                          + 0.6000000000000000D+00*dw(ijk,221,  5) &
                          + 0.6000000000000000D+00*dw(ijk,223,  5)
      JacC(ijk, 68,  5) = + 0.2000000000000000D+00*dw(ijk, 95,  5) &
                          + 0.5000000000000000D+00*dw(ijk, 96,  5) &
                           - dw(ijk,228,  5)
      JacC(ijk, 70, 38) = + 0.8000000000000000D+00*dw(ijk, 95, 38)
      JacC(ijk, 70,  5) = + 0.8000000000000000D+00*dw(ijk, 95,  5) &
                          + 0.8000000000000000D+00*dw(ijk, 98,  5) &
                          + 0.4300000000000000D+00*dw(ijk, 99,  5) &
                          + 0.1100000000000000D+00*dw(ijk,100,  5) &
                          + 0.9000000000000000D+00*dw(ijk,101,  5) &
                          + 0.9000000000000000D+00*dw(ijk,102,  5) &
                          + 0.1000000000000000D+00*dw(ijk,103,  5) &
                          + 0.1300000000000000D+00*dw(ijk,104,  5) &
                           - dw(ijk,230,  5)
      JacC(ijk,  4, 37) = + 0.5000000000000000D+00*dw(ijk, 96, 37)
      JacC(ijk,  5, 37) =  - dw(ijk, 96, 37)
      JacC(ijk,  8, 37) = + 0.5000000000000000D+00*dw(ijk, 96, 37)
      JacC(ijk, 33, 37) = + 0.2500000000000000D+00*dw(ijk, 96, 37) &
                          + 0.1600000000000000D+00*dw(ijk,114, 37)
      JacC(ijk, 34, 37) = + 0.3000000000000000D-01*dw(ijk, 96, 37)
      JacC(ijk, 34,  5) = + 0.3000000000000000D-01*dw(ijk, 96,  5) &
                          + 0.6700000000000000D+00*dw(ijk,215,  5) &
                          + 0.8280000000000000D+00*dw(ijk,216,  5) &
                          + 0.8800000000000000D+00*dw(ijk,217,  5) &
                          + 0.6000000000000000D-01*dw(ijk,219,  5) &
                          + 0.2900000000000000D+00*dw(ijk,220,  5) &
                           + dw(ijk,222,  5) &
                          + 0.4690000000000000D+00*dw(ijk,231,  5)
      JacC(ijk, 37,  5) =  - dw(ijk, 96,  5) &
                          + 0.5000000000000000D+00*dw(ijk,224,  5) &
                           + dw(ijk,225,  5)
      JacC(ijk, 72,  5) = + 0.5000000000000000D+00*dw(ijk, 96,  5) &
                           + dw(ijk,105,  5) &
                          + 0.5100000000000000D-01*dw(ijk,215,  5) &
                          + 0.3910000000000000D+00*dw(ijk,216,  5) &
                          + 0.5870000000000000D+00*dw(ijk,217,  5) &
                          + 0.1600000000000000D+00*dw(ijk,229,  5) &
                           - dw(ijk,237,  5)
      JacC(ijk,  5, 31) =  - dw(ijk, 97, 31)
      JacC(ijk,  8, 31) =  + dw(ijk, 97, 31)
      JacC(ijk, 31,  5) =  - dw(ijk, 97,  5)
      JacC(ijk, 60,  5) =  + dw(ijk, 97,  5)
      JacC(ijk,  5, 22) =  - dw(ijk, 98, 22)
      JacC(ijk, 22,  5) =  - dw(ijk, 98,  5)
      JacC(ijk, 70, 22) = + 0.8000000000000000D+00*dw(ijk, 98, 22)
      JacC(ijk, 71, 22) = + 0.2000000000000000D+00*dw(ijk, 98, 22)
      JacC(ijk, 71,  5) = + 0.2000000000000000D+00*dw(ijk, 98,  5) &
                          + 0.5700000000000000D+00*dw(ijk, 99,  5) &
                          + 0.8900000000000000D+00*dw(ijk,100,  5) &
                          + 0.1000000000000000D+00*dw(ijk,101,  5) &
                          + 0.1000000000000000D+00*dw(ijk,102,  5) &
                          + 0.9000000000000000D+00*dw(ijk,103,  5) &
                          + 0.8700000000000000D+00*dw(ijk,104,  5) &
                           - dw(ijk,231,  5)
      JacC(ijk,  5, 23) =  - dw(ijk, 99, 23)
      JacC(ijk, 23,  5) =  - dw(ijk, 99,  5) &
                          + 0.4000000000000000D+00*dw(ijk,221,  5)
      JacC(ijk, 70, 23) = + 0.4300000000000000D+00*dw(ijk, 99, 23)
      JacC(ijk, 71, 23) = + 0.5700000000000000D+00*dw(ijk, 99, 23)
      JacC(ijk,  5, 24) =  - dw(ijk,100, 24)
      JacC(ijk, 24,  5) =  - dw(ijk,100,  5) &
                          + 0.4000000000000000D+00*dw(ijk,223,  5)
      JacC(ijk, 70, 24) = + 0.1100000000000000D+00*dw(ijk,100, 24)
      JacC(ijk, 71, 24) = + 0.8900000000000000D+00*dw(ijk,100, 24)
      JacC(ijk,  5, 25) =  - dw(ijk,101, 25)
      JacC(ijk, 25,  5) =  - dw(ijk,101,  5)
      JacC(ijk, 38, 25) = + 0.9000000000000000D+00*dw(ijk,101, 25) &
                          + 0.3900000000000000D+00*dw(ijk,109, 25)
      JacC(ijk, 70, 25) = + 0.9000000000000000D+00*dw(ijk,101, 25)
      JacC(ijk, 71, 25) = + 0.1000000000000000D+00*dw(ijk,101, 25)
      JacC(ijk,  5, 26) =  - dw(ijk,102, 26)
      JacC(ijk, 26,  5) =  - dw(ijk,102,  5)
      JacC(ijk, 38, 26) = + 0.9000000000000000D+00*dw(ijk,102, 26) &
                          + 0.3900000000000000D+00*dw(ijk,110, 26)
      JacC(ijk, 70, 26) = + 0.9000000000000000D+00*dw(ijk,102, 26)
      JacC(ijk, 71, 26) = + 0.1000000000000000D+00*dw(ijk,102, 26)
      JacC(ijk,  5, 27) =  - dw(ijk,103, 27)
      JacC(ijk, 27,  5) =  - dw(ijk,103,  5)
      JacC(ijk, 70, 27) = + 0.1000000000000000D+00*dw(ijk,103, 27)
      JacC(ijk, 71, 27) = + 0.9000000000000000D+00*dw(ijk,103, 27)
      JacC(ijk,  5, 28) =  - dw(ijk,104, 28)
      JacC(ijk, 28,  5) =  - dw(ijk,104,  5)
      JacC(ijk, 70, 28) = + 0.1300000000000000D+00*dw(ijk,104, 28)
      JacC(ijk, 71, 28) = + 0.8700000000000000D+00*dw(ijk,104, 28)
      JacC(ijk,  4, 43) = + 0.4000000000000000D+00*dw(ijk,105, 43) &
                          + 0.7000000000000000D+00*dw(ijk,115, 43) &
                           + dw(ijk,130, 43)
      JacC(ijk, 41, 43) = + 0.6000000000000000D+00*dw(ijk,105, 43)
      JacC(ijk, 41,  5) = + 0.6000000000000000D+00*dw(ijk,105,  5) &
                           + dw(ijk,230,  5)
      JacC(ijk, 42,  5) = + 0.4000000000000000D+00*dw(ijk,105,  5)
      JacC(ijk, 43,  5) =  - dw(ijk,105,  5)
      JacC(ijk,  1, 22) =  - dw(ijk,106, 22)
      JacC(ijk, 12, 22) = + 0.4300000000000000D+00*dw(ijk,106, 22)
      JacC(ijk, 12,  1) = + 0.4300000000000000D+00*dw(ijk,106,  1) &
                          + 0.3700000000000000D+00*dw(ijk,107,  1) &
                          + 0.3000000000000000D+00*dw(ijk,108,  1) &
                          + 0.3600000000000000D+00*dw(ijk,109,  1) &
                          + 0.3600000000000000D+00*dw(ijk,110,  1) &
                          + 0.1400000000000000D+00*dw(ijk,111,  1) &
                          + 0.1400000000000000D+00*dw(ijk,112,  1) &
                          + 0.5400000000000000D+00*dw(ijk,113,  1) &
                          + 0.6600000000000000D+00*dw(ijk,114,  1) &
                          + 0.1300000000000000D+00*dw(ijk,115,  1)
      JacC(ijk, 16, 22) = + 0.2600000000000000D+00*dw(ijk,106, 22)
      JacC(ijk, 22,  1) =  - dw(ijk,106,  1)
      JacC(ijk, 32, 22) =  + dw(ijk,106, 22)
      JacC(ijk, 32,  1) =  + dw(ijk,106,  1) &
                          + 0.6400000000000000D+00*dw(ijk,107,  1) &
                          + 0.2000000000000000D-01*dw(ijk,108,  1) &
                          + 0.9000000000000000D+00*dw(ijk,109,  1) &
                          + 0.9000000000000000D+00*dw(ijk,110,  1) &
                          + 0.4000000000000000D-01*dw(ijk,112,  1) &
                          + 0.4000000000000000D+00*dw(ijk,113,  1) &
                          + 0.7000000000000000D+00*dw(ijk,115,  1)
      JacC(ijk, 47, 22) = + 0.3700000000000000D+00*dw(ijk,106, 22)
      JacC(ijk, 47,  1) = + 0.3700000000000000D+00*dw(ijk,106,  1) &
                          + 0.1400000000000000D+00*dw(ijk,107,  1) &
                          + 0.1500000000000000D+00*dw(ijk,109,  1) &
                          + 0.1500000000000000D+00*dw(ijk,110,  1) &
                          + 0.1000000000000000D-01*dw(ijk,112,  1) &
                          + 0.2200000000000000D+00*dw(ijk,113,  1) &
                          + 0.1100000000000000D+00*dw(ijk,114,  1) &
                          + 0.1100000000000000D+00*dw(ijk,115,  1)
      JacC(ijk,  1, 23) =  - dw(ijk,107, 23)
      JacC(ijk,  2, 23) = + 0.6000000000000000D-02*dw(ijk,107, 23)
      JacC(ijk,  2,  1) = + 0.6000000000000000D-02*dw(ijk,107,  1) &
                          + 0.1100000000000000D-01*dw(ijk,108,  1) &
                          + 0.1000000000000000D-02*dw(ijk,109,  1) &
                          + 0.1000000000000000D-02*dw(ijk,110,  1) &
                          + 0.2000000000000000D-01*dw(ijk,111,  1) &
                          + 0.2000000000000000D-01*dw(ijk,112,  1)
      JacC(ijk, 12, 23) = + 0.3700000000000000D+00*dw(ijk,107, 23)
      JacC(ijk, 16, 23) = + 0.2500000000000000D+00*dw(ijk,107, 23)
      JacC(ijk, 17, 23) = + 0.6000000000000000D-01*dw(ijk,107, 23)
      JacC(ijk, 17,  1) = + 0.6000000000000000D-01*dw(ijk,107,  1) &
                          + 0.7000000000000001D-01*dw(ijk,108,  1)
      JacC(ijk, 18, 23) = + 0.3000000000000000D-01*dw(ijk,107, 23)
      JacC(ijk, 18,  1) = + 0.3000000000000000D-01*dw(ijk,107,  1) &
                          + 0.6000000000000000D-01*dw(ijk,108,  1)
      JacC(ijk, 23,  1) =  - dw(ijk,107,  1) &
                          + 0.3500000000000000D+00*dw(ijk,109,  1) &
                          + 0.3500000000000000D+00*dw(ijk,110,  1) &
                          + 0.4600000000000000D+00*dw(ijk,112,  1)
      JacC(ijk, 32, 23) = + 0.6400000000000000D+00*dw(ijk,107, 23)
      JacC(ijk, 33, 23) = + 0.4400000000000000D+00*dw(ijk,107, 23)
      JacC(ijk, 33,  1) = + 0.4400000000000000D+00*dw(ijk,107,  1) &
                          + 0.9900000000000000D+00*dw(ijk,108,  1) &
                          + 0.6500000000000000D+00*dw(ijk,111,  1) &
                          + 0.1600000000000000D+00*dw(ijk,114,  1)
      JacC(ijk, 34, 23) = + 0.3000000000000000D-01*dw(ijk,107, 23)
      JacC(ijk, 34,  1) = + 0.3000000000000000D-01*dw(ijk,107,  1) &
                          + 0.1600000000000000D+00*dw(ijk,108,  1) &
                          + 0.5300000000000000D+00*dw(ijk,111,  1)
      JacC(ijk, 47, 23) = + 0.1400000000000000D+00*dw(ijk,107, 23)
      JacC(ijk, 48, 23) = + 0.1000000000000000D+00*dw(ijk,107, 23)
      JacC(ijk, 48,  1) = + 0.1000000000000000D+00*dw(ijk,107,  1) &
                          + 0.1400000000000000D+00*dw(ijk,108,  1) &
                          + 0.7000000000000001D-01*dw(ijk,112,  1) &
                          + 0.1300000000000000D+00*dw(ijk,113,  1) &
                          + 0.2100000000000000D+00*dw(ijk,114,  1)
      JacC(ijk, 49, 23) = + 0.1900000000000000D+00*dw(ijk,107, 23)
      JacC(ijk, 49,  1) = + 0.1900000000000000D+00*dw(ijk,107,  1) &
                          + 0.2300000000000000D+00*dw(ijk,108,  1) &
                          + 0.3000000000000000D-01*dw(ijk,109,  1) &
                          + 0.3000000000000000D-01*dw(ijk,110,  1)
      JacC(ijk, 50, 23) = + 0.1000000000000000D+00*dw(ijk,107, 23)
      JacC(ijk, 50,  1) = + 0.1000000000000000D+00*dw(ijk,107,  1) &
                          + 0.1800000000000000D+00*dw(ijk,108,  1) &
                          + 0.2000000000000000D+00*dw(ijk,111,  1) &
                          + 0.1600000000000000D+00*dw(ijk,112,  1)
      JacC(ijk, 69, 23) = + 0.3000000000000000D-01*dw(ijk,107, 23)
      JacC(ijk, 69,  1) = + 0.3000000000000000D-01*dw(ijk,107,  1) &
                          + 0.1200000000000000D+00*dw(ijk,108,  1) &
                          + 0.2000000000000000D-01*dw(ijk,109,  1) &
                          + 0.2000000000000000D-01*dw(ijk,110,  1) &
                          + 0.4200000000000000D+00*dw(ijk,111,  1) &
                          + 0.4200000000000000D+00*dw(ijk,112,  1)
      JacC(ijk,  1, 24) =  - dw(ijk,108, 24)
      JacC(ijk,  2, 24) = + 0.1100000000000000D-01*dw(ijk,108, 24)
      JacC(ijk, 12, 24) = + 0.3000000000000000D+00*dw(ijk,108, 24)
      JacC(ijk, 16, 24) = + 0.2200000000000000D+00*dw(ijk,108, 24)
      JacC(ijk, 17, 24) = + 0.7000000000000001D-01*dw(ijk,108, 24)
      JacC(ijk, 18, 24) = + 0.6000000000000000D-01*dw(ijk,108, 24)
      JacC(ijk, 24,  1) =  - dw(ijk,108,  1)
      JacC(ijk, 32, 24) = + 0.2000000000000000D-01*dw(ijk,108, 24)
      JacC(ijk, 33, 24) = + 0.9900000000000000D+00*dw(ijk,108, 24)
      JacC(ijk, 34, 24) = + 0.1600000000000000D+00*dw(ijk,108, 24)
      JacC(ijk, 48, 24) = + 0.1400000000000000D+00*dw(ijk,108, 24)
      JacC(ijk, 49, 24) = + 0.2300000000000000D+00*dw(ijk,108, 24)
      JacC(ijk, 50, 24) = + 0.1800000000000000D+00*dw(ijk,108, 24)
      JacC(ijk, 69, 24) = + 0.1200000000000000D+00*dw(ijk,108, 24)
      JacC(ijk,  1, 25) =  - dw(ijk,109, 25)
      JacC(ijk,  2, 25) = + 0.1000000000000000D-02*dw(ijk,109, 25)
      JacC(ijk, 12, 25) = + 0.3600000000000000D+00*dw(ijk,109, 25)
      JacC(ijk, 13, 25) = + 0.9000000000000000D-01*dw(ijk,109, 25)
      JacC(ijk, 16, 25) = + 0.3000000000000000D+00*dw(ijk,109, 25)
      JacC(ijk, 23, 25) = + 0.3500000000000000D+00*dw(ijk,109, 25)
      JacC(ijk, 25,  1) =  - dw(ijk,109,  1)
      JacC(ijk, 32, 25) = + 0.9000000000000000D+00*dw(ijk,109, 25)
      JacC(ijk, 38,  1) = + 0.3900000000000000D+00*dw(ijk,109,  1) &
                          + 0.3900000000000000D+00*dw(ijk,110,  1) &
                          + 0.7900000000000000D+00*dw(ijk,112,  1) &
                           - dw(ijk,113,  1)
      JacC(ijk, 47, 25) = + 0.1500000000000000D+00*dw(ijk,109, 25)
      JacC(ijk, 49, 25) = + 0.3000000000000000D-01*dw(ijk,109, 25)
      JacC(ijk, 67, 25) = + 0.1500000000000000D+00*dw(ijk,109, 25)
      JacC(ijk, 67,  1) = + 0.1500000000000000D+00*dw(ijk,109,  1) &
                          + 0.1500000000000000D+00*dw(ijk,110,  1) &
                          + 0.1300000000000000D+00*dw(ijk,113,  1) &
                          + 0.2800000000000000D+00*dw(ijk,114,  1) &
                          + 0.7000000000000000D+00*dw(ijk,115,  1)
      JacC(ijk, 69, 25) = + 0.2000000000000000D-01*dw(ijk,109, 25)
      JacC(ijk, 72, 25) = + 0.1300000000000000D+00*dw(ijk,109, 25)
      JacC(ijk, 72,  1) = + 0.1300000000000000D+00*dw(ijk,109,  1) &
                          + 0.1300000000000000D+00*dw(ijk,110,  1)
      JacC(ijk,  1, 26) =  - dw(ijk,110, 26)
      JacC(ijk,  2, 26) = + 0.1000000000000000D-02*dw(ijk,110, 26)
      JacC(ijk, 26,  1) =  - dw(ijk,110,  1)
      JacC(ijk, 47, 26) = + 0.1500000000000000D+00*dw(ijk,110, 26)
      JacC(ijk, 49, 26) = + 0.3000000000000000D-01*dw(ijk,110, 26)
      JacC(ijk, 67, 26) = + 0.1500000000000000D+00*dw(ijk,110, 26)
      JacC(ijk, 69, 26) = + 0.2000000000000000D-01*dw(ijk,110, 26)
      JacC(ijk,  1, 27) =  - dw(ijk,111, 27)
      JacC(ijk,  2, 27) = + 0.2000000000000000D-01*dw(ijk,111, 27)
      JacC(ijk, 12, 27) = + 0.1400000000000000D+00*dw(ijk,111, 27)
      JacC(ijk, 16, 27) = + 0.1000000000000000D+00*dw(ijk,111, 27)
      JacC(ijk, 27,  1) =  - dw(ijk,111,  1)
      JacC(ijk, 33, 27) = + 0.6500000000000000D+00*dw(ijk,111, 27)
      JacC(ijk, 34, 27) = + 0.5300000000000000D+00*dw(ijk,111, 27)
      JacC(ijk, 50, 27) = + 0.2000000000000000D+00*dw(ijk,111, 27)
      JacC(ijk, 69, 27) = + 0.4200000000000000D+00*dw(ijk,111, 27)
      JacC(ijk,  1, 28) =  - dw(ijk,112, 28)
      JacC(ijk,  2, 28) = + 0.2000000000000000D-01*dw(ijk,112, 28)
      JacC(ijk, 12, 28) = + 0.1400000000000000D+00*dw(ijk,112, 28)
      JacC(ijk, 16, 28) = + 0.1000000000000000D+00*dw(ijk,112, 28)
      JacC(ijk, 23, 28) = + 0.4600000000000000D+00*dw(ijk,112, 28)
      JacC(ijk, 28,  1) =  - dw(ijk,112,  1)
      JacC(ijk, 32, 28) = + 0.4000000000000000D-01*dw(ijk,112, 28)
      JacC(ijk, 38, 28) = + 0.7900000000000000D+00*dw(ijk,112, 28)
      JacC(ijk, 47, 28) = + 0.1000000000000000D-01*dw(ijk,112, 28)
      JacC(ijk, 48, 28) = + 0.7000000000000001D-01*dw(ijk,112, 28)
      JacC(ijk, 50, 28) = + 0.1600000000000000D+00*dw(ijk,112, 28)
      JacC(ijk, 69, 28) = + 0.4200000000000000D+00*dw(ijk,112, 28)
      JacC(ijk,  1, 38) =  - dw(ijk,113, 38)
      JacC(ijk, 36,  1) = + 0.6000000000000000D+00*dw(ijk,113,  1) &
                          + 0.6200000000000000D+00*dw(ijk,114,  1)
      JacC(ijk, 45, 38) = + 0.1300000000000000D+00*dw(ijk,113, 38)
      JacC(ijk, 45,  1) = + 0.1300000000000000D+00*dw(ijk,113,  1)
      JacC(ijk, 47, 38) = + 0.2200000000000000D+00*dw(ijk,113, 38)
      JacC(ijk, 48, 38) = + 0.1300000000000000D+00*dw(ijk,113, 38)
      JacC(ijk,  1, 37) =  - dw(ijk,114, 37)
      JacC(ijk, 12, 37) = + 0.6600000000000000D+00*dw(ijk,114, 37)
      JacC(ijk, 35,  1) = + 0.5000000000000000D+00*dw(ijk,114,  1)
      JacC(ijk, 37,  1) =  - dw(ijk,114,  1)
      JacC(ijk, 46, 37) = + 0.1100000000000000D+00*dw(ijk,114, 37)
      JacC(ijk, 46,  1) = + 0.1100000000000000D+00*dw(ijk,114,  1)
      JacC(ijk, 47, 37) = + 0.1100000000000000D+00*dw(ijk,114, 37)
      JacC(ijk, 48, 37) = + 0.2100000000000000D+00*dw(ijk,114, 37)
      JacC(ijk, 67, 37) = + 0.2800000000000000D+00*dw(ijk,114, 37)
      JacC(ijk,  1, 43) =  - dw(ijk,115, 43)
      JacC(ijk, 12, 43) = + 0.1300000000000000D+00*dw(ijk,115, 43)
      JacC(ijk, 42,  1) = + 0.3000000000000000D+00*dw(ijk,115,  1)
      JacC(ijk, 43,  1) =  - dw(ijk,115,  1)
      JacC(ijk, 47, 43) = + 0.1100000000000000D+00*dw(ijk,115, 43)
      JacC(ijk, 67, 43) = + 0.7000000000000000D+00*dw(ijk,115, 43)
      JacC(ijk,  4, 60) =  - dw(ijk,116, 60)
      JacC(ijk, 31, 60) = + 0.1000000000000000D+00*dw(ijk,116, 60) &
                           + dw(ijk,117, 60)
      JacC(ijk, 31,  4) = + 0.1000000000000000D+00*dw(ijk,116,  4) &
                           + dw(ijk,118,  4) &
                           + dw(ijk,121,  4) &
                           + dw(ijk,124,  4)
      JacC(ijk, 41, 60) =  + dw(ijk,116, 60)
      JacC(ijk, 41,  4) =  + dw(ijk,116,  4)
      JacC(ijk, 60, 60) =  - dw(ijk,116, 60) &
                           - dw(ijk,117, 60)
      JacC(ijk, 60,  4) =  - dw(ijk,116,  4)
      JacC(ijk, 16, 60) =  - dw(ijk,117, 60)
      JacC(ijk, 31, 16) =  + dw(ijk,117, 16)
      JacC(ijk, 60, 16) =  - dw(ijk,117, 16)
      JacC(ijk,  4, 61) =  - dw(ijk,118, 61)
      JacC(ijk,  7, 61) =  + dw(ijk,118, 61)
      JacC(ijk,  7,  4) =  + dw(ijk,118,  4) &
                           + dw(ijk,121,  4) &
                           + dw(ijk,124,  4)
      JacC(ijk, 31, 61) =  + dw(ijk,118, 61) &
                          + 0.2000000000000000D-01*dw(ijk,119, 61) &
                           + dw(ijk,120, 61)
      JacC(ijk, 61, 61) =  - dw(ijk,118, 61) &
                           - dw(ijk,119, 61) &
                           - dw(ijk,120, 61)
      JacC(ijk, 61,  4) =  - dw(ijk,118,  4)
      JacC(ijk, 16, 61) = + 0.2000000000000000D-01*dw(ijk,119, 61)
      JacC(ijk, 64, 61) = + 0.9800000000000000D+00*dw(ijk,119, 61)
      JacC(ijk,  1, 61) =  - dw(ijk,120, 61)
      JacC(ijk, 15, 61) =  + dw(ijk,120, 61)
      JacC(ijk, 31,  1) =  + dw(ijk,120,  1) &
                           + dw(ijk,123,  1) &
                           + dw(ijk,126,  1)
      JacC(ijk, 61,  1) =  - dw(ijk,120,  1)
      JacC(ijk,  4, 62) =  - dw(ijk,121, 62)
      JacC(ijk,  7, 62) =  + dw(ijk,121, 62)
      JacC(ijk, 31, 62) =  + dw(ijk,121, 62) &
                          + 0.2000000000000000D-01*dw(ijk,122, 62) &
                           + dw(ijk,123, 62)
      JacC(ijk, 62, 62) =  - dw(ijk,121, 62) &
                           - dw(ijk,122, 62) &
                           - dw(ijk,123, 62)
      JacC(ijk, 62,  4) =  - dw(ijk,121,  4)
      JacC(ijk, 16, 62) = + 0.2000000000000000D-01*dw(ijk,122, 62)
      JacC(ijk, 65, 62) = + 0.9800000000000000D+00*dw(ijk,122, 62)
      JacC(ijk,  1, 62) =  - dw(ijk,123, 62)
      JacC(ijk, 15, 62) =  + dw(ijk,123, 62)
      JacC(ijk, 62,  1) =  - dw(ijk,123,  1)
      JacC(ijk,  4, 63) =  - dw(ijk,124, 63)
      JacC(ijk,  7, 63) =  + dw(ijk,124, 63)
      JacC(ijk, 31, 63) =  + dw(ijk,124, 63) &
                          + 0.2000000000000000D-01*dw(ijk,125, 63) &
                           + dw(ijk,126, 63)
      JacC(ijk, 63, 63) =  - dw(ijk,124, 63) &
                           - dw(ijk,125, 63) &
                           - dw(ijk,126, 63)
      JacC(ijk, 63,  4) =  - dw(ijk,124,  4)
      JacC(ijk, 16, 63) = + 0.2000000000000000D-01*dw(ijk,125, 63)
      JacC(ijk, 66, 63) = + 0.9800000000000000D+00*dw(ijk,125, 63)
      JacC(ijk,  1, 63) =  - dw(ijk,126, 63)
      JacC(ijk, 15, 63) =  + dw(ijk,126, 63)
      JacC(ijk, 63,  1) =  - dw(ijk,126,  1)
      JacC(ijk,  4, 67) =  - dw(ijk,127, 67) &
                           + dw(ijk,145, 67) &
                          + 0.5160000000000000D+00*dw(ijk,209, 67) &
                           + dw(ijk,227, 67)
      JacC(ijk, 42, 67) =  + dw(ijk,127, 67)
      JacC(ijk, 42,  4) =  + dw(ijk,127,  4)
      JacC(ijk, 67, 67) =  - dw(ijk,127, 67) &
                           - dw(ijk,145, 67) &
                           - dw(ijk,164, 67) &
                           - dw(ijk,165, 67) &
                           - dw(ijk,185, 67) &
                           - dw(ijk,186, 67) &
                           - dw(ijk,192, 67) &
                           - dw(ijk,193, 67) &
                           - dw(ijk,194, 67) &
                           - dw(ijk,195, 67) &
                           - dw(ijk,196, 67) &
                           - dw(ijk,197, 67) &
                           - dw(ijk,198, 67) &
                           - dw(ijk,199, 67) &
                           - dw(ijk,200, 67) &
                           - dw(ijk,201, 67) &
                           - dw(ijk,202, 67) &
                           - dw(ijk,203, 67) &
                           - dw(ijk,204, 67) &
                          - 0.2000000000000000D+01*dw(ijk,205, 67) &
                          - 0.2000000000000000D+01*dw(ijk,205, 67) &
                          - 0.8800000000000000D+00*dw(ijk,207, 67) &
                           - dw(ijk,208, 67) &
                           - dw(ijk,209, 67) &
                           - dw(ijk,227, 67) &
                           - dw(ijk,234, 67)
      JacC(ijk, 67,  4) =  - dw(ijk,127,  4)
      JacC(ijk,  4, 42) =  + dw(ijk,128, 42)
      JacC(ijk, 67, 42) =  + dw(ijk,128, 42)
      JacC(ijk,  4, 68) =  - dw(ijk,129, 68) &
                           + dw(ijk,146, 68) &
                           + dw(ijk,228, 68)
      JacC(ijk, 43, 68) =  + dw(ijk,129, 68)
      JacC(ijk, 43,  4) =  + dw(ijk,129,  4)
      JacC(ijk, 68, 68) =  - dw(ijk,129, 68) &
                           - dw(ijk,146, 68) &
                           - dw(ijk,166, 68) &
                           - dw(ijk,167, 68) &
                           - dw(ijk,187, 68) &
                           - dw(ijk,188, 68) &
                           - dw(ijk,206, 68) &
                           - dw(ijk,228, 68)
      JacC(ijk, 68,  4) =  - dw(ijk,129,  4)
      JacC(ijk, 68, 43) =  + dw(ijk,130, 43)
      JacC(ijk,  3, 49) =  - dw(ijk,131, 49)
      JacC(ijk,  4, 49) =  + dw(ijk,131, 49) &
                          + 0.5000000000000000D+00*dw(ijk,191, 49) &
                           + dw(ijk,213, 49)
      JacC(ijk, 16, 49) =  + dw(ijk,131, 49) &
                           - dw(ijk,150, 49) &
                          + 0.6600000000000000D+00*dw(ijk,171, 49) &
                          + 0.6600000000000000D+00*dw(ijk,171, 49) &
                           + dw(ijk,172, 49) &
                          + 0.9920000000000000D+00*dw(ijk,173, 49) &
                          + 0.9460000000000000D+00*dw(ijk,174, 49) &
                          + 0.9930000000000000D+00*dw(ijk,175, 49) &
                           + dw(ijk,176, 49) &
                           + dw(ijk,177, 49) &
                           + dw(ijk,178, 49) &
                           + dw(ijk,179, 49) &
                          + 0.2000000000000000D+01*dw(ijk,180, 49) &
                          + 0.2000000000000000D+01*dw(ijk,181, 49) &
                           + dw(ijk,182, 49) &
                           + dw(ijk,183, 49) &
                          + 0.2000000000000000D+01*dw(ijk,184, 49) &
                           + dw(ijk,185, 49) &
                           + dw(ijk,187, 49) &
                          + 0.8800000000000000D+00*dw(ijk,189, 49) &
                           + dw(ijk,190, 49) &
                          + 0.5000000000000000D+00*dw(ijk,191, 49) &
                           + dw(ijk,213, 49) &
                           + dw(ijk,233, 49)
      JacC(ijk, 32, 49) =  + dw(ijk,131, 49) &
                          + 0.1330000000000000D+01*dw(ijk,171, 49) &
                          + 0.1330000000000000D+01*dw(ijk,171, 49) &
                          + 0.7500000000000000D+00*dw(ijk,172, 49) &
                          + 0.8100000000000001D+00*dw(ijk,173, 49) &
                          + 0.8290000000000000D+00*dw(ijk,174, 49) &
                          + 0.7530000000000000D+00*dw(ijk,175, 49) &
                          + 0.1550000000000000D+01*dw(ijk,176, 49) &
                          + 0.1250000000000000D+01*dw(ijk,177, 49) &
                          + 0.7550000000000000D+00*dw(ijk,178, 49) &
                          + 0.1090000000000000D+01*dw(ijk,179, 49) &
                           + dw(ijk,180, 49) &
                          + 0.1400000000000000D+01*dw(ijk,181, 49) &
                           + dw(ijk,182, 49) &
                           + dw(ijk,183, 49) &
                           + dw(ijk,184, 49) &
                           + dw(ijk,185, 49) &
                           + dw(ijk,186, 49) &
                          + 0.2000000000000000D+01*dw(ijk,187, 49) &
                           + dw(ijk,188, 49) &
                          + 0.7500000000000000D+00*dw(ijk,189, 49) &
                          + 0.7500000000000000D+00*dw(ijk,190, 49) &
                          + 0.9600000000000000D+00*dw(ijk,191, 49) &
                           + dw(ijk,213, 49) &
                           + dw(ijk,233, 49)
      JacC(ijk, 32,  3) =  + dw(ijk,131,  3) &
                          + 0.4700000000000000D-01*dw(ijk,133,  3) &
                          + 0.2100000000000000D-01*dw(ijk,134,  3) &
                          + 0.1600000000000000D+01*dw(ijk,136,  3) &
                           + dw(ijk,137,  3) &
                          + 0.6060000000000000D+00*dw(ijk,139,  3) &
                          + 0.2500000000000000D+00*dw(ijk,141,  3) &
                           + dw(ijk,146,  3) &
                          + 0.2870000000000000D+00*dw(ijk,149,  3)
      JacC(ijk, 49, 49) =  - dw(ijk,131, 49) &
                           - dw(ijk,150, 49) &
                          - 0.2000000000000000D+01*dw(ijk,171, 49) &
                          - 0.2000000000000000D+01*dw(ijk,171, 49) &
                           - dw(ijk,172, 49) &
                          - 0.9930000000000000D+00*dw(ijk,173, 49) &
                          - 0.9510000000000000D+00*dw(ijk,174, 49) &
                           - dw(ijk,175, 49) &
                           - dw(ijk,176, 49) &
                           - dw(ijk,177, 49) &
                           - dw(ijk,178, 49) &
                           - dw(ijk,179, 49) &
                           - dw(ijk,180, 49) &
                           - dw(ijk,181, 49) &
                           - dw(ijk,182, 49) &
                           - dw(ijk,183, 49) &
                           - dw(ijk,184, 49) &
                           - dw(ijk,186, 49) &
                           - dw(ijk,187, 49) &
                           - dw(ijk,188, 49) &
                           - dw(ijk,189, 49) &
                           - dw(ijk,190, 49) &
                           - dw(ijk,191, 49) &
                           - dw(ijk,213, 49) &
                           - dw(ijk,233, 49)
      JacC(ijk, 49,  3) =  - dw(ijk,131,  3) &
                          + 0.1500000000000000D+00*dw(ijk,133,  3) &
                          + 0.3100000000000000D-01*dw(ijk,134,  3) &
                           + dw(ijk,145,  3)
      JacC(ijk,  3, 50) =  - dw(ijk,132, 50)
      JacC(ijk,  4, 50) =  + dw(ijk,132, 50) &
                           + dw(ijk,214, 50)
      JacC(ijk, 16, 50) =  + dw(ijk,132, 50) &
                           - dw(ijk,151, 50) &
                           + dw(ijk,172, 50) &
                          + 0.5000000000000000D+00*dw(ijk,192, 50) &
                           + dw(ijk,214, 50)
      JacC(ijk, 33, 50) =  + dw(ijk,132, 50) &
                          + 0.7500000000000000D+00*dw(ijk,172, 50) &
                           + dw(ijk,192, 50) &
                           + dw(ijk,214, 50)
      JacC(ijk, 33,  3) =  + dw(ijk,132,  3) &
                          + 0.2330000000000000D+00*dw(ijk,133,  3) &
                          + 0.2110000000000000D+00*dw(ijk,134,  3) &
                          + 0.1500000000000000D+00*dw(ijk,135,  3) &
                          + 0.2000000000000000D+00*dw(ijk,136,  3) &
                          + 0.9399999999999999D+00*dw(ijk,137,  3) &
                          + 0.1710000000000000D+01*dw(ijk,138,  3) &
                          + 0.8000000000000000D+00*dw(ijk,140,  3) &
                          + 0.4600000000000000D+00*dw(ijk,147,  3) &
                          + 0.1240000000000000D+01*dw(ijk,149,  3)
      JacC(ijk, 50, 50) =  - dw(ijk,132, 50) &
                           - dw(ijk,151, 50) &
                           - dw(ijk,172, 50) &
                           - dw(ijk,192, 50) &
                           - dw(ijk,214, 50)
      JacC(ijk, 50,  3) =  - dw(ijk,132,  3) &
                          + 0.4800000000000000D-01*dw(ijk,133,  3) &
                          + 0.2450000000000000D+00*dw(ijk,134,  3) &
                          + 0.1330000000000000D+00*dw(ijk,135,  3)
      JacC(ijk,  3, 51) =  - dw(ijk,133, 51)
      JacC(ijk,  4, 51) = + 0.9409999999999999D+00*dw(ijk,133, 51) &
                           + dw(ijk,215, 51)
      JacC(ijk, 16, 51) = + 0.7420000000000000D+00*dw(ijk,133, 51) &
                           - dw(ijk,152, 51) &
                          + 0.9920000000000000D+00*dw(ijk,173, 51) &
                          + 0.4880000000000000D+00*dw(ijk,193, 51) &
                          + 0.7920000000000000D+00*dw(ijk,215, 51)
      JacC(ijk, 32, 51) = + 0.4700000000000000D-01*dw(ijk,133, 51) &
                          + 0.8100000000000001D+00*dw(ijk,173, 51) &
                          + 0.9100000000000000D-01*dw(ijk,193, 51) &
                          + 0.4800000000000000D-01*dw(ijk,215, 51)
      JacC(ijk, 33, 51) = + 0.2330000000000000D+00*dw(ijk,133, 51) &
                          + 0.5800000000000000D+00*dw(ijk,173, 51) &
                          + 0.7240000000000000D+00*dw(ijk,193, 51) &
                          + 0.2430000000000000D+00*dw(ijk,215, 51)
      JacC(ijk, 34, 51) = + 0.6230000000000000D+00*dw(ijk,133, 51) &
                          + 0.1800000000000000D-01*dw(ijk,173, 51) &
                          + 0.1270000000000000D+00*dw(ijk,193, 51) &
                          + 0.6700000000000000D+00*dw(ijk,215, 51)
      JacC(ijk, 34,  3) = + 0.6230000000000000D+00*dw(ijk,133,  3) &
                          + 0.7220000000000000D+00*dw(ijk,134,  3) &
                          + 0.6420000000000000D+00*dw(ijk,135,  3) &
                          + 0.6000000000000000D-01*dw(ijk,137,  3) &
                          + 0.2900000000000000D+00*dw(ijk,138,  3) &
                          + 0.8000000000000000D+00*dw(ijk,140,  3) &
                          + 0.4640000000000000D+00*dw(ijk,149,  3)
      JacC(ijk, 35, 51) = + 0.6300000000000000D-01*dw(ijk,133, 51) &
                          + 0.1190000000000000D+00*dw(ijk,173, 51) &
                          + 0.1000000000000000D+00*dw(ijk,193, 51) &
                          + 0.6300000000000000D-01*dw(ijk,215, 51)
      JacC(ijk, 35,  3) = + 0.6300000000000000D-01*dw(ijk,133,  3) &
                          + 0.1200000000000000D+01*dw(ijk,142,  3) &
                          + 0.3500000000000000D+00*dw(ijk,143,  3) &
                           + dw(ijk,144,  3)
      JacC(ijk, 41, 51) = + 0.5900000000000000D-01*dw(ijk,133, 51)
      JacC(ijk, 41,  3) = + 0.5900000000000000D-01*dw(ijk,133,  3) &
                          + 0.1240000000000000D+00*dw(ijk,134,  3) &
                          + 0.2610000000000000D+00*dw(ijk,135,  3) &
                          + 0.1530000000000000D+00*dw(ijk,139,  3) &
                          + 0.2000000000000000D+00*dw(ijk,140,  3) &
                          + 0.3500000000000000D+00*dw(ijk,141,  3) &
                          + 0.5000000000000000D-01*dw(ijk,142,  3) &
                          + 0.5000000000000000D-01*dw(ijk,143,  3) &
                           + dw(ijk,148,  3)
      JacC(ijk, 49, 51) = + 0.1500000000000000D+00*dw(ijk,133, 51) &
                          - 0.9930000000000000D+00*dw(ijk,173, 51) &
                          + 0.5080000000000000D+00*dw(ijk,193, 51) &
                          + 0.1550000000000000D+00*dw(ijk,215, 51)
      JacC(ijk, 50, 51) = + 0.4800000000000000D-01*dw(ijk,133, 51) &
                          + 0.6000000000000000D-02*dw(ijk,193, 51) &
                          + 0.5300000000000000D-01*dw(ijk,215, 51)
      JacC(ijk, 51, 51) =  - dw(ijk,133, 51) &
                           - dw(ijk,152, 51) &
                           - dw(ijk,173, 51) &
                           - dw(ijk,193, 51) &
                           - dw(ijk,215, 51)
      JacC(ijk, 51,  3) =  - dw(ijk,133,  3)
      JacC(ijk, 72, 51) = + 0.4800000000000000D-01*dw(ijk,133, 51) &
                          + 0.8500000000000001D-01*dw(ijk,173, 51) &
                          + 0.7099999999999999D-01*dw(ijk,193, 51) &
                          + 0.5100000000000000D-01*dw(ijk,215, 51)
      JacC(ijk, 72,  3) = + 0.4800000000000000D-01*dw(ijk,133,  3) &
                          + 0.3340000000000000D+00*dw(ijk,134,  3) &
                          + 0.4160000000000000D+00*dw(ijk,135,  3) &
                          + 0.1600000000000000D+00*dw(ijk,147,  3) &
                           - dw(ijk,236,  3)
      JacC(ijk,  3, 52) =  - dw(ijk,134, 52)
      JacC(ijk,  4, 52) = + 0.8760000000000000D+00*dw(ijk,134, 52) &
                           + dw(ijk,216, 52)
      JacC(ijk, 16, 52) = + 0.5990000000000000D+00*dw(ijk,134, 52) &
                           - dw(ijk,153, 52) &
                          + 0.9460000000000000D+00*dw(ijk,174, 52) &
                          + 0.4380000000000000D+00*dw(ijk,194, 52) &
                          + 0.6990000000000000D+00*dw(ijk,216, 52)
      JacC(ijk, 32, 52) = + 0.2100000000000000D-01*dw(ijk,134, 52) &
                          + 0.8290000000000000D+00*dw(ijk,174, 52) &
                          + 0.7600000000000000D-01*dw(ijk,194, 52) &
                          + 0.2100000000000000D-01*dw(ijk,216, 52)
      JacC(ijk, 33, 52) = + 0.2110000000000000D+00*dw(ijk,134, 52) &
                          + 0.5230000000000000D+00*dw(ijk,174, 52) &
                          + 0.6770000000000000D+00*dw(ijk,194, 52) &
                          + 0.2390000000000000D+00*dw(ijk,216, 52)
      JacC(ijk, 34, 52) = + 0.7220000000000000D+00*dw(ijk,134, 52) &
                          + 0.2400000000000000D+00*dw(ijk,174, 52) &
                          + 0.3300000000000000D+00*dw(ijk,194, 52) &
                          + 0.8280000000000000D+00*dw(ijk,216, 52)
      JacC(ijk, 41, 52) = + 0.1240000000000000D+00*dw(ijk,134, 52)
      JacC(ijk, 49, 52) = + 0.3100000000000000D-01*dw(ijk,134, 52) &
                          - 0.9510000000000000D+00*dw(ijk,174, 52) &
                          + 0.5540000000000000D+00*dw(ijk,194, 52) &
                          + 0.4000000000000000D-01*dw(ijk,216, 52)
      JacC(ijk, 50, 52) = + 0.2450000000000000D+00*dw(ijk,134, 52) &
                          + 0.1400000000000000D-01*dw(ijk,174, 52) &
                          + 0.1800000000000000D-01*dw(ijk,194, 52) &
                          + 0.2620000000000000D+00*dw(ijk,216, 52)
      JacC(ijk, 52, 52) =  - dw(ijk,134, 52) &
                           - dw(ijk,153, 52) &
                           - dw(ijk,174, 52) &
                           - dw(ijk,194, 52) &
                           - dw(ijk,216, 52)
      JacC(ijk, 52,  3) =  - dw(ijk,134,  3)
      JacC(ijk, 72, 52) = + 0.3340000000000000D+00*dw(ijk,134, 52) &
                          + 0.2450000000000000D+00*dw(ijk,174, 52) &
                          + 0.2370000000000000D+00*dw(ijk,194, 52) &
                          + 0.3910000000000000D+00*dw(ijk,216, 52)
      JacC(ijk,  3, 53) =  - dw(ijk,135, 53)
      JacC(ijk,  4, 53) = + 0.7390000000000000D+00*dw(ijk,135, 53) &
                           + dw(ijk,217, 53)
      JacC(ijk, 16, 53) = + 0.6060000000000000D+00*dw(ijk,135, 53) &
                           - dw(ijk,154, 53) &
                          + 0.9930000000000000D+00*dw(ijk,175, 53) &
                          + 0.4890000000000000D+00*dw(ijk,195, 53) &
                          + 0.8450000000000000D+00*dw(ijk,217, 53)
      JacC(ijk, 33, 53) = + 0.1500000000000000D+00*dw(ijk,135, 53) &
                          + 0.4110000000000000D+00*dw(ijk,175, 53) &
                          + 0.4970000000000000D+00*dw(ijk,195, 53) &
                          + 0.1870000000000000D+00*dw(ijk,217, 53)
      JacC(ijk, 34, 53) = + 0.6420000000000000D+00*dw(ijk,135, 53) &
                          + 0.4190000000000000D+00*dw(ijk,175, 53) &
                          + 0.5810000000000000D+00*dw(ijk,195, 53) &
                          + 0.8800000000000000D+00*dw(ijk,217, 53)
      JacC(ijk, 41, 53) = + 0.2610000000000000D+00*dw(ijk,135, 53)
      JacC(ijk, 50, 53) = + 0.1330000000000000D+00*dw(ijk,135, 53) &
                          + 0.1300000000000000D-01*dw(ijk,175, 53) &
                          + 0.1500000000000000D-01*dw(ijk,195, 53) &
                          + 0.1550000000000000D+00*dw(ijk,217, 53)
      JacC(ijk, 53, 53) =  - dw(ijk,135, 53) &
                           - dw(ijk,154, 53) &
                           - dw(ijk,175, 53) &
                           - dw(ijk,195, 53) &
                           - dw(ijk,217, 53)
      JacC(ijk, 53,  3) =  - dw(ijk,135,  3)
      JacC(ijk, 72, 53) = + 0.4160000000000000D+00*dw(ijk,135, 53) &
                          + 0.3220000000000000D+00*dw(ijk,175, 53) &
                          + 0.3180000000000000D+00*dw(ijk,195, 53) &
                          + 0.5870000000000000D+00*dw(ijk,217, 53)
      JacC(ijk,  3, 54) =  - dw(ijk,136, 54)
      JacC(ijk,  4, 54) =  + dw(ijk,136, 54) &
                           + dw(ijk,218, 54)
      JacC(ijk, 16, 54) =  + dw(ijk,136, 54) &
                           - dw(ijk,155, 54) &
                           + dw(ijk,176, 54) &
                          + 0.5000000000000000D+00*dw(ijk,196, 54) &
                           + dw(ijk,218, 54)
      JacC(ijk, 32, 54) = + 0.1600000000000000D+01*dw(ijk,136, 54) &
                          + 0.1550000000000000D+01*dw(ijk,176, 54) &
                          + 0.8000000000000000D+00*dw(ijk,196, 54) &
                          + 0.1600000000000000D+01*dw(ijk,218, 54)
      JacC(ijk, 33, 54) = + 0.2000000000000000D+00*dw(ijk,136, 54) &
                          + 0.3500000000000000D+00*dw(ijk,176, 54) &
                          + 0.6000000000000000D+00*dw(ijk,196, 54) &
                          + 0.2000000000000000D+00*dw(ijk,218, 54)
      JacC(ijk, 54, 54) =  - dw(ijk,136, 54) &
                           - dw(ijk,155, 54) &
                           - dw(ijk,176, 54) &
                           - dw(ijk,196, 54) &
                           - dw(ijk,218, 54)
      JacC(ijk, 54,  3) =  - dw(ijk,136,  3)
      JacC(ijk,  3, 55) =  - dw(ijk,137, 55)
      JacC(ijk,  4, 55) =  + dw(ijk,137, 55) &
                           + dw(ijk,219, 55)
      JacC(ijk, 16, 55) =  + dw(ijk,137, 55) &
                           - dw(ijk,156, 55) &
                           + dw(ijk,177, 55) &
                          + 0.5010000000000000D+00*dw(ijk,197, 55) &
                           + dw(ijk,219, 55)
      JacC(ijk, 32, 55) =  + dw(ijk,137, 55) &
                          + 0.1250000000000000D+01*dw(ijk,177, 55) &
                          + 0.5010000000000000D+00*dw(ijk,197, 55) &
                           + dw(ijk,219, 55)
      JacC(ijk, 33, 55) = + 0.9399999999999999D+00*dw(ijk,137, 55) &
                          + 0.6690000000000000D+00*dw(ijk,177, 55) &
                          + 0.8590000000000000D+00*dw(ijk,197, 55) &
                          + 0.9399999999999999D+00*dw(ijk,219, 55)
      JacC(ijk, 34, 55) = + 0.6000000000000000D-01*dw(ijk,137, 55) &
                          + 0.8100000000000000D-01*dw(ijk,177, 55) &
                          + 0.1410000000000000D+00*dw(ijk,197, 55) &
                          + 0.6000000000000000D-01*dw(ijk,219, 55)
      JacC(ijk, 55, 55) =  - dw(ijk,137, 55) &
                           - dw(ijk,156, 55) &
                           - dw(ijk,177, 55) &
                           - dw(ijk,197, 55) &
                           - dw(ijk,219, 55)
      JacC(ijk, 55,  3) =  - dw(ijk,137,  3)
      JacC(ijk,  3, 56) =  - dw(ijk,138, 56)
      JacC(ijk,  4, 56) =  + dw(ijk,138, 56) &
                           + dw(ijk,220, 56)
      JacC(ijk, 16, 56) =  + dw(ijk,138, 56) &
                           - dw(ijk,157, 56) &
                           + dw(ijk,178, 56) &
                          + 0.5100000000000000D+00*dw(ijk,198, 56) &
                           + dw(ijk,220, 56)
      JacC(ijk, 33, 56) = + 0.1710000000000000D+01*dw(ijk,138, 56) &
                          + 0.9320000000000001D+00*dw(ijk,178, 56) &
                          + 0.9409999999999999D+00*dw(ijk,198, 56) &
                          + 0.1710000000000000D+01*dw(ijk,220, 56)
      JacC(ijk, 34, 56) = + 0.2900000000000000D+00*dw(ijk,138, 56) &
                          + 0.3130000000000000D+00*dw(ijk,178, 56) &
                          + 0.5690000000000000D+00*dw(ijk,198, 56) &
                          + 0.2900000000000000D+00*dw(ijk,220, 56)
      JacC(ijk, 56, 56) =  - dw(ijk,138, 56) &
                           - dw(ijk,157, 56) &
                           - dw(ijk,178, 56) &
                           - dw(ijk,198, 56) &
                           - dw(ijk,220, 56)
      JacC(ijk, 56,  3) =  - dw(ijk,138,  3)
      JacC(ijk,  3, 57) =  - dw(ijk,139, 57)
      JacC(ijk,  4, 57) = + 0.8470000000000000D+00*dw(ijk,139, 57) &
                           + dw(ijk,221, 57)
      JacC(ijk, 16, 57) = + 0.8470000000000000D+00*dw(ijk,139, 57) &
                           - dw(ijk,158, 57) &
                           + dw(ijk,179, 57) &
                          + 0.5060000000000000D+00*dw(ijk,199, 57) &
                           + dw(ijk,221, 57)
      JacC(ijk, 23, 57) = + 0.3540000000000000D+00*dw(ijk,139, 57) &
                          + 0.3700000000000000D+00*dw(ijk,179, 57) &
                          + 0.2290000000000000D+00*dw(ijk,199, 57) &
                          + 0.4000000000000000D+00*dw(ijk,221, 57)
      JacC(ijk, 23,  3) = + 0.3540000000000000D+00*dw(ijk,139,  3)
      JacC(ijk, 32, 57) = + 0.6060000000000000D+00*dw(ijk,139, 57) &
                          + 0.1090000000000000D+01*dw(ijk,179, 57) &
                          + 0.3400000000000000D+00*dw(ijk,199, 57) &
                          + 0.6860000000000001D+00*dw(ijk,221, 57)
      JacC(ijk, 38, 57) = + 0.4460000000000000D+00*dw(ijk,139, 57) &
                          + 0.5500000000000000D+00*dw(ijk,179, 57) &
                          + 0.7710000000000000D+00*dw(ijk,199, 57) &
                          + 0.6000000000000000D+00*dw(ijk,221, 57)
      JacC(ijk, 38,  3) = + 0.4460000000000000D+00*dw(ijk,139,  3) &
                          + 0.4000000000000000D+00*dw(ijk,141,  3)
      JacC(ijk, 41, 57) = + 0.1530000000000000D+00*dw(ijk,139, 57)
      JacC(ijk, 57, 57) =  - dw(ijk,139, 57) &
                           - dw(ijk,158, 57) &
                           - dw(ijk,179, 57) &
                           - dw(ijk,199, 57) &
                           - dw(ijk,221, 57)
      JacC(ijk, 57,  3) =  - dw(ijk,139,  3)
      JacC(ijk,  3, 58) =  - dw(ijk,140, 58)
      JacC(ijk,  4, 58) = + 0.8000000000000000D+00*dw(ijk,140, 58) &
                           + dw(ijk,222, 58)
      JacC(ijk, 16, 58) = + 0.8000000000000000D+00*dw(ijk,140, 58) &
                           - dw(ijk,159, 58) &
                          + 0.2000000000000000D+01*dw(ijk,180, 58) &
                           + dw(ijk,200, 58) &
                           + dw(ijk,222, 58)
      JacC(ijk, 33, 58) = + 0.8000000000000000D+00*dw(ijk,140, 58) &
                           + dw(ijk,180, 58) &
                           + dw(ijk,200, 58) &
                           + dw(ijk,222, 58)
      JacC(ijk, 34, 58) = + 0.8000000000000000D+00*dw(ijk,140, 58) &
                           + dw(ijk,180, 58) &
                           + dw(ijk,200, 58) &
                           + dw(ijk,222, 58)
      JacC(ijk, 41, 58) = + 0.2000000000000000D+00*dw(ijk,140, 58)
      JacC(ijk, 58, 58) =  - dw(ijk,140, 58) &
                           - dw(ijk,159, 58) &
                           - dw(ijk,180, 58) &
                           - dw(ijk,200, 58) &
                           - dw(ijk,222, 58)
      JacC(ijk, 58,  3) =  - dw(ijk,140,  3)
      JacC(ijk,  3, 59) =  - dw(ijk,141, 59)
      JacC(ijk,  4, 59) = + 0.6500000000000000D+00*dw(ijk,141, 59) &
                           + dw(ijk,223, 59)
      JacC(ijk, 16, 59) = + 0.6500000000000000D+00*dw(ijk,141, 59) &
                           - dw(ijk,160, 59) &
                          + 0.2000000000000000D+01*dw(ijk,181, 59) &
                           + dw(ijk,201, 59) &
                           + dw(ijk,223, 59)
      JacC(ijk, 24, 59) = + 0.2500000000000000D+00*dw(ijk,141, 59) &
                          + 0.4000000000000000D+00*dw(ijk,181, 59) &
                          + 0.4000000000000000D+00*dw(ijk,201, 59) &
                          + 0.4000000000000000D+00*dw(ijk,223, 59)
      JacC(ijk, 24,  3) = + 0.2500000000000000D+00*dw(ijk,141,  3)
      JacC(ijk, 32, 59) = + 0.2500000000000000D+00*dw(ijk,141, 59) &
                          + 0.1400000000000000D+01*dw(ijk,181, 59) &
                          + 0.4000000000000000D+00*dw(ijk,201, 59) &
                          + 0.4000000000000000D+00*dw(ijk,223, 59)
      JacC(ijk, 38, 59) = + 0.4000000000000000D+00*dw(ijk,141, 59) &
                          + 0.6000000000000000D+00*dw(ijk,181, 59) &
                          + 0.6000000000000000D+00*dw(ijk,201, 59) &
                          + 0.6000000000000000D+00*dw(ijk,223, 59)
      JacC(ijk, 41, 59) = + 0.3500000000000000D+00*dw(ijk,141, 59)
      JacC(ijk, 59, 59) =  - dw(ijk,141, 59) &
                           - dw(ijk,160, 59) &
                           - dw(ijk,181, 59) &
                           - dw(ijk,201, 59) &
                           - dw(ijk,223, 59)
      JacC(ijk, 59,  3) =  - dw(ijk,141,  3)
      JacC(ijk,  3, 64) =  - dw(ijk,142, 64)
      JacC(ijk,  4, 64) = + 0.9500000000000000D+00*dw(ijk,142, 64) &
                           + dw(ijk,224, 64)
      JacC(ijk, 16, 64) = + 0.9500000000000000D+00*dw(ijk,142, 64) &
                           - dw(ijk,161, 64) &
                           + dw(ijk,182, 64) &
                           + dw(ijk,202, 64) &
                           + dw(ijk,224, 64)
      JacC(ijk, 35, 64) = + 0.1200000000000000D+01*dw(ijk,142, 64) &
                          + 0.6500000000000000D+00*dw(ijk,182, 64) &
                          + 0.6500000000000000D+00*dw(ijk,202, 64) &
                          + 0.1300000000000000D+01*dw(ijk,224, 64)
      JacC(ijk, 36, 64) = + 0.6500000000000000D+00*dw(ijk,142, 64) &
                          + 0.3500000000000000D+00*dw(ijk,182, 64) &
                          + 0.3500000000000000D+00*dw(ijk,202, 64) &
                          + 0.7000000000000000D+00*dw(ijk,224, 64)
      JacC(ijk, 36,  3) = + 0.6500000000000000D+00*dw(ijk,142,  3) &
                          + 0.6000000000000000D+00*dw(ijk,143,  3) &
                           + dw(ijk,144,  3) &
                          + 0.5400000000000000D+00*dw(ijk,147,  3)
      JacC(ijk, 37, 64) = + 0.5000000000000000D+00*dw(ijk,142, 64) &
                           + dw(ijk,182, 64) &
                           + dw(ijk,202, 64) &
                          + 0.5000000000000000D+00*dw(ijk,224, 64)
      JacC(ijk, 37,  3) = + 0.5000000000000000D+00*dw(ijk,142,  3) &
                          + 0.9500000000000000D+00*dw(ijk,143,  3)
      JacC(ijk, 41, 64) = + 0.5000000000000000D-01*dw(ijk,142, 64)
      JacC(ijk, 64, 64) =  - dw(ijk,142, 64) &
                           - dw(ijk,161, 64) &
                           - dw(ijk,182, 64) &
                           - dw(ijk,202, 64) &
                           - dw(ijk,224, 64)
      JacC(ijk, 64,  3) =  - dw(ijk,142,  3)
      JacC(ijk,  3, 65) =  - dw(ijk,143, 65)
      JacC(ijk,  4, 65) = + 0.9500000000000000D+00*dw(ijk,143, 65) &
                           + dw(ijk,225, 65)
      JacC(ijk, 16, 65) = + 0.9500000000000000D+00*dw(ijk,143, 65) &
                           - dw(ijk,162, 65) &
                           + dw(ijk,183, 65) &
                           + dw(ijk,203, 65) &
                           + dw(ijk,225, 65)
      JacC(ijk, 35, 65) = + 0.3500000000000000D+00*dw(ijk,143, 65) &
                          + 0.3700000000000000D+00*dw(ijk,183, 65) &
                          + 0.3700000000000000D+00*dw(ijk,203, 65) &
                          + 0.7400000000000000D+00*dw(ijk,225, 65)
      JacC(ijk, 36, 65) = + 0.6000000000000000D+00*dw(ijk,143, 65) &
                          + 0.6300000000000000D+00*dw(ijk,183, 65) &
                          + 0.6300000000000000D+00*dw(ijk,203, 65) &
                          + 0.1260000000000000D+01*dw(ijk,225, 65)
      JacC(ijk, 37, 65) = + 0.9500000000000000D+00*dw(ijk,143, 65) &
                           + dw(ijk,183, 65) &
                           + dw(ijk,203, 65) &
                           + dw(ijk,225, 65)
      JacC(ijk, 41, 65) = + 0.5000000000000000D-01*dw(ijk,143, 65)
      JacC(ijk, 65, 65) =  - dw(ijk,143, 65) &
                           - dw(ijk,162, 65) &
                           - dw(ijk,183, 65) &
                           - dw(ijk,203, 65) &
                           - dw(ijk,225, 65)
      JacC(ijk, 65,  3) =  - dw(ijk,143,  3)
      JacC(ijk,  3, 66) =  - dw(ijk,144, 66)
      JacC(ijk,  4, 66) =  + dw(ijk,144, 66) &
                           + dw(ijk,226, 66)
      JacC(ijk, 16, 66) =  + dw(ijk,144, 66) &
                           - dw(ijk,163, 66) &
                          + 0.2000000000000000D+01*dw(ijk,184, 66) &
                           + dw(ijk,204, 66) &
                           + dw(ijk,226, 66)
      JacC(ijk, 35, 66) =  + dw(ijk,144, 66) &
                           + dw(ijk,184, 66) &
                           + dw(ijk,204, 66) &
                           + dw(ijk,226, 66)
      JacC(ijk, 36, 66) =  + dw(ijk,144, 66) &
                           + dw(ijk,184, 66) &
                           + dw(ijk,204, 66) &
                           + dw(ijk,226, 66)
      JacC(ijk, 66, 66) =  - dw(ijk,144, 66) &
                           - dw(ijk,163, 66) &
                           - dw(ijk,184, 66) &
                           - dw(ijk,204, 66) &
                           - dw(ijk,226, 66)
      JacC(ijk, 66,  3) =  - dw(ijk,144,  3)
      JacC(ijk,  3, 67) =  - dw(ijk,145, 67)
      JacC(ijk, 49, 67) =  + dw(ijk,145, 67) &
                           - dw(ijk,186, 67) &
                          + 0.5000000000000000D+00*dw(ijk,192, 67) &
                          + 0.5080000000000000D+00*dw(ijk,193, 67) &
                          + 0.5540000000000000D+00*dw(ijk,194, 67) &
                          + 0.5070000000000000D+00*dw(ijk,195, 67) &
                          + 0.5000000000000000D+00*dw(ijk,196, 67) &
                          + 0.5010000000000000D+00*dw(ijk,197, 67) &
                          + 0.5100000000000000D+00*dw(ijk,198, 67) &
                          + 0.5060000000000000D+00*dw(ijk,199, 67) &
                           + dw(ijk,200, 67) &
                           + dw(ijk,201, 67) &
                           + dw(ijk,202, 67) &
                           + dw(ijk,203, 67) &
                           + dw(ijk,204, 67) &
                          + 0.2000000000000000D+01*dw(ijk,205, 67) &
                          + 0.2000000000000000D+01*dw(ijk,205, 67) &
                           + dw(ijk,206, 67) &
                          + 0.5000000000000000D+00*dw(ijk,207, 67) &
                          + 0.5000000000000000D+00*dw(ijk,208, 67) &
                          + 0.5160000000000000D+00*dw(ijk,209, 67) &
                           + dw(ijk,227, 67) &
                           + dw(ijk,234, 67)
      JacC(ijk, 67,  3) =  - dw(ijk,145,  3) &
                           + dw(ijk,146,  3) &
                          + 0.2300000000000000D+00*dw(ijk,147,  3)
      JacC(ijk,  3, 68) =  - dw(ijk,146, 68)
      JacC(ijk, 32, 68) =  + dw(ijk,146, 68) &
                          + 0.2000000000000000D+01*dw(ijk,187, 68) &
                           + dw(ijk,188, 68) &
                           + dw(ijk,206, 68) &
                           + dw(ijk,228, 68)
      JacC(ijk, 67, 68) =  + dw(ijk,146, 68) &
                           + dw(ijk,187, 68) &
                           + dw(ijk,228, 68)
      JacC(ijk, 68,  3) =  - dw(ijk,146,  3)
      JacC(ijk,  3, 69) =  - dw(ijk,147, 69)
      JacC(ijk,  4, 69) =  + dw(ijk,147, 69) &
                           + dw(ijk,229, 69)
      JacC(ijk, 16, 69) = + 0.7700000000000000D+00*dw(ijk,147, 69) &
                           - dw(ijk,168, 69) &
                          + 0.8800000000000000D+00*dw(ijk,189, 69) &
                          + 0.3800000000000000D+00*dw(ijk,207, 69) &
                          + 0.7700000000000000D+00*dw(ijk,229, 69)
      JacC(ijk, 33, 69) = + 0.4600000000000000D+00*dw(ijk,147, 69) &
                          + 0.3000000000000000D+00*dw(ijk,189, 69) &
                          + 0.3500000000000000D+00*dw(ijk,207, 69) &
                          + 0.4600000000000000D+00*dw(ijk,229, 69)
      JacC(ijk, 36, 69) = + 0.5400000000000000D+00*dw(ijk,147, 69) &
                          + 0.4000000000000000D+00*dw(ijk,189, 69) &
                          + 0.5400000000000000D+00*dw(ijk,207, 69) &
                          + 0.5400000000000000D+00*dw(ijk,229, 69)
      JacC(ijk, 67, 69) = + 0.2300000000000000D+00*dw(ijk,147, 69) &
                          + 0.1200000000000000D+00*dw(ijk,189, 69) &
                          - 0.8800000000000000D+00*dw(ijk,207, 69) &
                          + 0.2300000000000000D+00*dw(ijk,229, 69)
      JacC(ijk, 69, 69) =  - dw(ijk,147, 69) &
                           - dw(ijk,168, 69) &
                           - dw(ijk,189, 69) &
                           - dw(ijk,207, 69) &
                           - dw(ijk,229, 69)
      JacC(ijk, 69,  3) =  - dw(ijk,147,  3)
      JacC(ijk, 72, 69) = + 0.1600000000000000D+00*dw(ijk,147, 69) &
                          + 0.8000000000000000D-01*dw(ijk,189, 69) &
                          + 0.8000000000000000D-01*dw(ijk,207, 69) &
                          + 0.1600000000000000D+00*dw(ijk,229, 69)
      JacC(ijk,  3, 70) =  - dw(ijk,148, 70)
      JacC(ijk,  4, 70) =  + dw(ijk,148, 70) &
                          + 0.5000000000000000D+00*dw(ijk,211, 70) &
                           + dw(ijk,230, 70)
      JacC(ijk, 16, 70) =  + dw(ijk,148, 70) &
                           - dw(ijk,169, 70) &
                           + dw(ijk,190, 70) &
                          + 0.5000000000000000D+00*dw(ijk,208, 70) &
                           + dw(ijk,210, 70) &
                           + dw(ijk,210, 70) &
                          + 0.5000000000000000D+00*dw(ijk,211, 70) &
                           + dw(ijk,230, 70)
      JacC(ijk, 41, 70) =  + dw(ijk,148, 70) &
                           + dw(ijk,169, 70) &
                           + dw(ijk,190, 70) &
                           + dw(ijk,208, 70) &
                          + 0.2000000000000000D+01*dw(ijk,210, 70) &
                          + 0.2000000000000000D+01*dw(ijk,210, 70) &
                          + 0.1500000000000000D+01*dw(ijk,211, 70) &
                           + dw(ijk,230, 70)
      JacC(ijk, 70, 70) =  - dw(ijk,148, 70) &
                           - dw(ijk,169, 70) &
                           - dw(ijk,190, 70) &
                           - dw(ijk,208, 70) &
                          - 0.2000000000000000D+01*dw(ijk,210, 70) &
                          - 0.2000000000000000D+01*dw(ijk,210, 70) &
                           - dw(ijk,211, 70) &
                           - dw(ijk,230, 70)
      JacC(ijk, 70,  3) =  - dw(ijk,148,  3)
      JacC(ijk,  3, 71) =  - dw(ijk,149, 71)
      JacC(ijk,  4, 71) = + 0.2000000000000000D+01*dw(ijk,149, 71) &
                          + 0.5000000000000000D+00*dw(ijk,191, 71) &
                          + 0.5160000000000000D+00*dw(ijk,209, 71) &
                          + 0.5000000000000000D+00*dw(ijk,211, 71) &
                           + dw(ijk,212, 71) &
                           + dw(ijk,212, 71) &
                          + 0.2000000000000000D+01*dw(ijk,231, 71)
      JacC(ijk, 32, 71) = + 0.2870000000000000D+00*dw(ijk,149, 71) &
                          + 0.9600000000000000D+00*dw(ijk,191, 71) &
                          + 0.2070000000000000D+00*dw(ijk,209, 71) &
                          + 0.2020000000000000D+00*dw(ijk,211, 71) &
                          + 0.5040000000000000D+00*dw(ijk,212, 71) &
                          + 0.5040000000000000D+00*dw(ijk,212, 71) &
                          + 0.2800000000000000D+00*dw(ijk,231, 71)
      JacC(ijk, 33, 71) = + 0.1240000000000000D+01*dw(ijk,149, 71) &
                          + 0.6400000000000000D+00*dw(ijk,191, 71) &
                          + 0.6500000000000000D+00*dw(ijk,209, 71) &
                          + 0.6400000000000000D+00*dw(ijk,211, 71) &
                          + 0.1210000000000000D+01*dw(ijk,212, 71) &
                          + 0.1210000000000000D+01*dw(ijk,212, 71) &
                          + 0.1240000000000000D+01*dw(ijk,231, 71)
      JacC(ijk, 34, 71) = + 0.4640000000000000D+00*dw(ijk,149, 71) &
                          + 0.1490000000000000D+00*dw(ijk,191, 71) &
                          + 0.1670000000000000D+00*dw(ijk,209, 71) &
                          + 0.1490000000000000D+00*dw(ijk,211, 71) &
                          + 0.2850000000000000D+00*dw(ijk,212, 71) &
                          + 0.2850000000000000D+00*dw(ijk,212, 71) &
                          + 0.4690000000000000D+00*dw(ijk,231, 71)
      JacC(ijk, 71, 71) =  - dw(ijk,149, 71) &
                           - dw(ijk,170, 71) &
                           - dw(ijk,191, 71) &
                           - dw(ijk,209, 71) &
                           - dw(ijk,211, 71) &
                          - 0.2000000000000000D+01*dw(ijk,212, 71) &
                          - 0.2000000000000000D+01*dw(ijk,212, 71) &
                           - dw(ijk,231, 71)
      JacC(ijk, 71,  3) =  - dw(ijk,149,  3)
      JacC(ijk, 44, 49) =  + dw(ijk,150, 49)
      JacC(ijk, 44, 16) =  + dw(ijk,150, 16)
      JacC(ijk, 49, 16) =  - dw(ijk,150, 16)
      JacC(ijk, 45, 50) =  + dw(ijk,151, 50)
      JacC(ijk, 45, 16) =  + dw(ijk,151, 16) &
                           + dw(ijk,152, 16) &
                           + dw(ijk,153, 16) &
                           + dw(ijk,154, 16) &
                           + dw(ijk,155, 16) &
                           + dw(ijk,156, 16) &
                           + dw(ijk,157, 16) &
                           + dw(ijk,158, 16) &
                           + dw(ijk,159, 16) &
                           + dw(ijk,160, 16) &
                           + dw(ijk,161, 16) &
                           + dw(ijk,162, 16) &
                           + dw(ijk,163, 16) &
                           + dw(ijk,166, 16) &
                           + dw(ijk,168, 16) &
                           + dw(ijk,232, 16)
      JacC(ijk, 50, 16) =  - dw(ijk,151, 16)
      JacC(ijk, 45, 51) =  + dw(ijk,152, 51)
      JacC(ijk, 51, 16) =  - dw(ijk,152, 16)
      JacC(ijk, 45, 52) =  + dw(ijk,153, 52)
      JacC(ijk, 52, 16) =  - dw(ijk,153, 16)
      JacC(ijk, 45, 53) =  + dw(ijk,154, 53)
      JacC(ijk, 53, 16) =  - dw(ijk,154, 16)
      JacC(ijk, 45, 54) =  + dw(ijk,155, 54)
      JacC(ijk, 54, 16) =  - dw(ijk,155, 16)
      JacC(ijk, 45, 55) =  + dw(ijk,156, 55)
      JacC(ijk, 55, 16) =  - dw(ijk,156, 16)
      JacC(ijk, 45, 56) =  + dw(ijk,157, 56)
      JacC(ijk, 56, 16) =  - dw(ijk,157, 16)
      JacC(ijk, 45, 57) =  + dw(ijk,158, 57)
      JacC(ijk, 57, 16) =  - dw(ijk,158, 16)
      JacC(ijk, 45, 58) =  + dw(ijk,159, 58)
      JacC(ijk, 58, 16) =  - dw(ijk,159, 16)
      JacC(ijk, 45, 59) =  + dw(ijk,160, 59)
      JacC(ijk, 59, 16) =  - dw(ijk,160, 16)
      JacC(ijk, 45, 64) =  + dw(ijk,161, 64)
      JacC(ijk, 64, 16) =  - dw(ijk,161, 16)
      JacC(ijk, 45, 65) =  + dw(ijk,162, 65)
      JacC(ijk, 65, 16) =  - dw(ijk,162, 16)
      JacC(ijk, 45, 66) =  + dw(ijk,163, 66)
      JacC(ijk, 66, 16) =  - dw(ijk,163, 16)
      JacC(ijk, 16, 67) =  - dw(ijk,164, 67) &
                           - dw(ijk,165, 67) &
                           + dw(ijk,185, 67) &
                          + 0.5000000000000000D+00*dw(ijk,192, 67) &
                          + 0.4880000000000000D+00*dw(ijk,193, 67) &
                          + 0.4380000000000000D+00*dw(ijk,194, 67) &
                          + 0.4890000000000000D+00*dw(ijk,195, 67) &
                          + 0.5000000000000000D+00*dw(ijk,196, 67) &
                          + 0.5010000000000000D+00*dw(ijk,197, 67) &
                          + 0.5100000000000000D+00*dw(ijk,198, 67) &
                          + 0.5060000000000000D+00*dw(ijk,199, 67) &
                           + dw(ijk,200, 67) &
                           + dw(ijk,201, 67) &
                           + dw(ijk,202, 67) &
                           + dw(ijk,203, 67) &
                           + dw(ijk,204, 67) &
                          + 0.3800000000000000D+00*dw(ijk,207, 67) &
                          + 0.5000000000000000D+00*dw(ijk,208, 67)
      JacC(ijk, 46, 67) =  + dw(ijk,164, 67)
      JacC(ijk, 46, 16) =  + dw(ijk,164, 16)
      JacC(ijk, 67, 16) =  - dw(ijk,164, 16) &
                           - dw(ijk,165, 16)
      JacC(ijk,  1, 67) =  + dw(ijk,165, 67)
      JacC(ijk, 48, 67) =  + dw(ijk,165, 67) &
                           + dw(ijk,186, 67) &
                          + 0.5000000000000000D+00*dw(ijk,192, 67) &
                          + 0.4990000000000000D+00*dw(ijk,193, 67) &
                          + 0.4950000000000000D+00*dw(ijk,194, 67) &
                          + 0.4950000000000000D+00*dw(ijk,195, 67) &
                          + 0.5000000000000000D+00*dw(ijk,196, 67) &
                          + 0.4990000000000000D+00*dw(ijk,197, 67) &
                          + 0.4900000000000000D+00*dw(ijk,198, 67) &
                          + 0.4940000000000000D+00*dw(ijk,199, 67) &
                          + 0.5000000000000000D+00*dw(ijk,207, 67) &
                          + 0.5000000000000000D+00*dw(ijk,208, 67) &
                          + 0.4840000000000000D+00*dw(ijk,209, 67)
      JacC(ijk, 48, 16) =  + dw(ijk,165, 16) &
                           + dw(ijk,167, 16)
      JacC(ijk, 16, 68) =  - dw(ijk,166, 68) &
                           - dw(ijk,167, 68) &
                           + dw(ijk,187, 68)
      JacC(ijk, 45, 68) =  + dw(ijk,166, 68)
      JacC(ijk, 68, 16) =  - dw(ijk,166, 16) &
                           - dw(ijk,167, 16)
      JacC(ijk,  1, 68) =  + dw(ijk,167, 68)
      JacC(ijk, 48, 68) =  + dw(ijk,167, 68) &
                           + dw(ijk,188, 68)
      JacC(ijk, 45, 69) =  + dw(ijk,168, 69)
      JacC(ijk, 69, 16) =  - dw(ijk,168, 16)
      JacC(ijk, 41, 16) =  + dw(ijk,169, 16) &
                           + dw(ijk,170, 16)
      JacC(ijk, 70, 16) =  - dw(ijk,169, 16)
      JacC(ijk, 16, 71) =  - dw(ijk,170, 71) &
                          + 0.5000000000000000D+00*dw(ijk,191, 71) &
                          + 0.5000000000000000D+00*dw(ijk,211, 71)
      JacC(ijk, 41, 71) =  + dw(ijk,170, 71) &
                          + 0.5000000000000000D+00*dw(ijk,191, 71) &
                          + 0.4840000000000000D+00*dw(ijk,209, 71) &
                          + 0.1500000000000000D+01*dw(ijk,211, 71) &
                           + dw(ijk,212, 71) &
                           + dw(ijk,212, 71)
      JacC(ijk, 71, 16) =  - dw(ijk,170, 16)
      JacC(ijk, 32, 50) = + 0.7500000000000000D+00*dw(ijk,172, 50)
      JacC(ijk, 33, 49) = + 0.7500000000000000D+00*dw(ijk,172, 49) &
                          + 0.5800000000000000D+00*dw(ijk,173, 49) &
                          + 0.5230000000000000D+00*dw(ijk,174, 49) &
                          + 0.4110000000000000D+00*dw(ijk,175, 49) &
                          + 0.3500000000000000D+00*dw(ijk,176, 49) &
                          + 0.6690000000000000D+00*dw(ijk,177, 49) &
                          + 0.9320000000000001D+00*dw(ijk,178, 49) &
                           + dw(ijk,180, 49) &
                          + 0.3000000000000000D+00*dw(ijk,189, 49) &
                          + 0.6400000000000000D+00*dw(ijk,191, 49)
      JacC(ijk, 49, 50) =  - dw(ijk,172, 50) &
                          + 0.5000000000000000D+00*dw(ijk,192, 50)
      JacC(ijk, 50, 49) =  - dw(ijk,172, 49) &
                          + 0.1400000000000000D-01*dw(ijk,174, 49) &
                          + 0.1300000000000000D-01*dw(ijk,175, 49)
      JacC(ijk, 34, 49) = + 0.1800000000000000D-01*dw(ijk,173, 49) &
                          + 0.2400000000000000D+00*dw(ijk,174, 49) &
                          + 0.4190000000000000D+00*dw(ijk,175, 49) &
                          + 0.8100000000000000D-01*dw(ijk,177, 49) &
                          + 0.3130000000000000D+00*dw(ijk,178, 49) &
                           + dw(ijk,180, 49) &
                          + 0.1490000000000000D+00*dw(ijk,191, 49)
      JacC(ijk, 35, 49) = + 0.1190000000000000D+00*dw(ijk,173, 49) &
                          + 0.6500000000000000D+00*dw(ijk,182, 49) &
                          + 0.3700000000000000D+00*dw(ijk,183, 49) &
                           + dw(ijk,184, 49)
      JacC(ijk, 36, 51) = + 0.5000000000000000D-02*dw(ijk,173, 51) &
                          + 0.4000000000000000D-02*dw(ijk,193, 51)
      JacC(ijk, 36, 49) = + 0.5000000000000000D-02*dw(ijk,173, 49) &
                          + 0.3500000000000000D+00*dw(ijk,182, 49) &
                          + 0.6300000000000000D+00*dw(ijk,183, 49) &
                           + dw(ijk,184, 49) &
                          + 0.4000000000000000D+00*dw(ijk,189, 49)
      JacC(ijk, 51, 49) =  - dw(ijk,173, 49)
      JacC(ijk, 72, 49) = + 0.8500000000000001D-01*dw(ijk,173, 49) &
                          + 0.2450000000000000D+00*dw(ijk,174, 49) &
                          + 0.3220000000000000D+00*dw(ijk,175, 49) &
                          + 0.8000000000000000D-01*dw(ijk,189, 49) &
                           - dw(ijk,233, 49)
      JacC(ijk, 52, 49) =  - dw(ijk,174, 49)
      JacC(ijk, 32, 53) = + 0.7530000000000000D+00*dw(ijk,175, 53)
      JacC(ijk, 49, 53) =  - dw(ijk,175, 53) &
                          + 0.5070000000000000D+00*dw(ijk,195, 53)
      JacC(ijk, 53, 49) =  - dw(ijk,175, 49)
      JacC(ijk, 49, 54) =  - dw(ijk,176, 54) &
                          + 0.5000000000000000D+00*dw(ijk,196, 54)
      JacC(ijk, 54, 49) =  - dw(ijk,176, 49)
      JacC(ijk, 49, 55) =  - dw(ijk,177, 55) &
                          + 0.5010000000000000D+00*dw(ijk,197, 55)
      JacC(ijk, 55, 49) =  - dw(ijk,177, 49)
      JacC(ijk, 32, 56) = + 0.7550000000000000D+00*dw(ijk,178, 56)
      JacC(ijk, 49, 56) =  - dw(ijk,178, 56) &
                          + 0.5100000000000000D+00*dw(ijk,198, 56)
      JacC(ijk, 56, 49) =  - dw(ijk,178, 49)
      JacC(ijk, 23, 49) = + 0.3700000000000000D+00*dw(ijk,179, 49)
      JacC(ijk, 24, 57) = + 0.8000000000000000D-01*dw(ijk,179, 57)
      JacC(ijk, 24, 49) = + 0.8000000000000000D-01*dw(ijk,179, 49) &
                          + 0.4000000000000000D+00*dw(ijk,181, 49)
      JacC(ijk, 38, 49) = + 0.5500000000000000D+00*dw(ijk,179, 49) &
                          + 0.6000000000000000D+00*dw(ijk,181, 49)
      JacC(ijk, 49, 57) =  - dw(ijk,179, 57) &
                          + 0.5060000000000000D+00*dw(ijk,199, 57)
      JacC(ijk, 57, 49) =  - dw(ijk,179, 49)
      JacC(ijk, 32, 58) =  + dw(ijk,180, 58)
      JacC(ijk, 49, 58) =  - dw(ijk,180, 58) &
                           + dw(ijk,200, 58)
      JacC(ijk, 58, 49) =  - dw(ijk,180, 49)
      JacC(ijk, 49, 59) =  - dw(ijk,181, 59) &
                           + dw(ijk,201, 59)
      JacC(ijk, 59, 49) =  - dw(ijk,181, 49)
      JacC(ijk, 32, 64) =  + dw(ijk,182, 64)
      JacC(ijk, 37, 49) =  + dw(ijk,182, 49) &
                           + dw(ijk,183, 49)
      JacC(ijk, 49, 64) =  - dw(ijk,182, 64) &
                           + dw(ijk,202, 64)
      JacC(ijk, 64, 49) =  - dw(ijk,182, 49)
      JacC(ijk, 32, 65) =  + dw(ijk,183, 65)
      JacC(ijk, 49, 65) =  - dw(ijk,183, 65) &
                           + dw(ijk,203, 65)
      JacC(ijk, 65, 49) =  - dw(ijk,183, 49)
      JacC(ijk, 32, 66) =  + dw(ijk,184, 66)
      JacC(ijk, 49, 66) =  - dw(ijk,184, 66) &
                           + dw(ijk,204, 66)
      JacC(ijk, 66, 49) =  - dw(ijk,184, 49)
      JacC(ijk, 32, 67) =  + dw(ijk,185, 67) &
                           + dw(ijk,186, 67) &
                          + 0.9100000000000000D-01*dw(ijk,193, 67) &
                          + 0.7600000000000000D-01*dw(ijk,194, 67) &
                          + 0.8000000000000000D+00*dw(ijk,196, 67) &
                          + 0.5010000000000000D+00*dw(ijk,197, 67) &
                          + 0.3400000000000000D+00*dw(ijk,199, 67) &
                          + 0.4000000000000000D+00*dw(ijk,201, 67) &
                           + dw(ijk,206, 67) &
                          + 0.2070000000000000D+00*dw(ijk,209, 67)
      JacC(ijk, 67, 49) =  - dw(ijk,185, 49) &
                           - dw(ijk,186, 49) &
                           + dw(ijk,187, 49) &
                          + 0.1200000000000000D+00*dw(ijk,189, 49)
      JacC(ijk, 48, 49) =  + dw(ijk,186, 49) &
                           + dw(ijk,188, 49)
      JacC(ijk, 49, 68) =  - dw(ijk,187, 68) &
                           - dw(ijk,188, 68) &
                           + dw(ijk,206, 68)
      JacC(ijk, 68, 49) =  - dw(ijk,187, 49) &
                           - dw(ijk,188, 49)
      JacC(ijk, 32, 69) = + 0.7500000000000000D+00*dw(ijk,189, 69)
      JacC(ijk, 40, 69) = + 0.3000000000000000D+00*dw(ijk,189, 69)
      JacC(ijk, 40, 49) = + 0.3000000000000000D+00*dw(ijk,189, 49)
      JacC(ijk, 49, 69) =  - dw(ijk,189, 69) &
                          + 0.5000000000000000D+00*dw(ijk,207, 69)
      JacC(ijk, 69, 49) =  - dw(ijk,189, 49)
      JacC(ijk, 32, 70) = + 0.7500000000000000D+00*dw(ijk,190, 70) &
                          + 0.2020000000000000D+00*dw(ijk,211, 70)
      JacC(ijk, 41, 49) =  + dw(ijk,190, 49) &
                          + 0.5000000000000000D+00*dw(ijk,191, 49)
      JacC(ijk, 49, 70) =  - dw(ijk,190, 70) &
                          + 0.5000000000000000D+00*dw(ijk,208, 70)
      JacC(ijk, 70, 49) =  - dw(ijk,190, 49)
      JacC(ijk, 49, 71) =  - dw(ijk,191, 71) &
                          + 0.5160000000000000D+00*dw(ijk,209, 71)
      JacC(ijk, 71, 49) =  - dw(ijk,191, 49)
      JacC(ijk, 33, 67) =  + dw(ijk,192, 67) &
                          + 0.7240000000000000D+00*dw(ijk,193, 67) &
                          + 0.6770000000000000D+00*dw(ijk,194, 67) &
                          + 0.4970000000000000D+00*dw(ijk,195, 67) &
                          + 0.6000000000000000D+00*dw(ijk,196, 67) &
                          + 0.8590000000000000D+00*dw(ijk,197, 67) &
                          + 0.9409999999999999D+00*dw(ijk,198, 67) &
                           + dw(ijk,200, 67) &
                          + 0.3500000000000000D+00*dw(ijk,207, 67) &
                          + 0.6500000000000000D+00*dw(ijk,209, 67)
      JacC(ijk, 48, 50) = + 0.5000000000000000D+00*dw(ijk,192, 50)
      JacC(ijk, 50, 67) =  - dw(ijk,192, 67) &
                          + 0.6000000000000000D-02*dw(ijk,193, 67) &
                          + 0.1800000000000000D-01*dw(ijk,194, 67) &
                          + 0.1500000000000000D-01*dw(ijk,195, 67)
      JacC(ijk, 67, 50) =  - dw(ijk,192, 50)
      JacC(ijk, 34, 67) = + 0.1270000000000000D+00*dw(ijk,193, 67) &
                          + 0.3300000000000000D+00*dw(ijk,194, 67) &
                          + 0.5810000000000000D+00*dw(ijk,195, 67) &
                          + 0.1410000000000000D+00*dw(ijk,197, 67) &
                          + 0.5690000000000000D+00*dw(ijk,198, 67) &
                           + dw(ijk,200, 67) &
                          + 0.1100000000000000D+00*dw(ijk,207, 67) &
                          + 0.1670000000000000D+00*dw(ijk,209, 67)
      JacC(ijk, 35, 67) = + 0.1000000000000000D+00*dw(ijk,193, 67) &
                          + 0.6500000000000000D+00*dw(ijk,202, 67) &
                          + 0.3700000000000000D+00*dw(ijk,203, 67) &
                           + dw(ijk,204, 67)
      JacC(ijk, 36, 67) = + 0.4000000000000000D-02*dw(ijk,193, 67) &
                          + 0.3500000000000000D+00*dw(ijk,202, 67) &
                          + 0.6300000000000000D+00*dw(ijk,203, 67) &
                           + dw(ijk,204, 67) &
                          + 0.5400000000000000D+00*dw(ijk,207, 67)
      JacC(ijk, 48, 51) = + 0.4990000000000000D+00*dw(ijk,193, 51)
      JacC(ijk, 51, 67) =  - dw(ijk,193, 67)
      JacC(ijk, 67, 51) =  - dw(ijk,193, 51)
      JacC(ijk, 72, 67) = + 0.7099999999999999D-01*dw(ijk,193, 67) &
                          + 0.2370000000000000D+00*dw(ijk,194, 67) &
                          + 0.3180000000000000D+00*dw(ijk,195, 67) &
                          + 0.8000000000000000D-01*dw(ijk,207, 67) &
                           - dw(ijk,234, 67)
      JacC(ijk, 48, 52) = + 0.4950000000000000D+00*dw(ijk,194, 52)
      JacC(ijk, 52, 67) =  - dw(ijk,194, 67)
      JacC(ijk, 67, 52) =  - dw(ijk,194, 52)
      JacC(ijk, 48, 53) = + 0.4950000000000000D+00*dw(ijk,195, 53)
      JacC(ijk, 53, 67) =  - dw(ijk,195, 67)
      JacC(ijk, 67, 53) =  - dw(ijk,195, 53)
      JacC(ijk, 48, 54) = + 0.5000000000000000D+00*dw(ijk,196, 54)
      JacC(ijk, 54, 67) =  - dw(ijk,196, 67)
      JacC(ijk, 67, 54) =  - dw(ijk,196, 54)
      JacC(ijk, 48, 55) = + 0.4990000000000000D+00*dw(ijk,197, 55)
      JacC(ijk, 55, 67) =  - dw(ijk,197, 67)
      JacC(ijk, 67, 55) =  - dw(ijk,197, 55)
      JacC(ijk, 48, 56) = + 0.4900000000000000D+00*dw(ijk,198, 56)
      JacC(ijk, 56, 67) =  - dw(ijk,198, 67)
      JacC(ijk, 67, 56) =  - dw(ijk,198, 56)
      JacC(ijk, 23, 67) = + 0.2290000000000000D+00*dw(ijk,199, 67)
      JacC(ijk, 38, 67) = + 0.7710000000000000D+00*dw(ijk,199, 67) &
                          + 0.6000000000000000D+00*dw(ijk,201, 67)
      JacC(ijk, 48, 57) = + 0.4940000000000000D+00*dw(ijk,199, 57)
      JacC(ijk, 57, 67) =  - dw(ijk,199, 67)
      JacC(ijk, 67, 57) =  - dw(ijk,199, 57)
      JacC(ijk, 58, 67) =  - dw(ijk,200, 67)
      JacC(ijk, 67, 58) =  - dw(ijk,200, 58)
      JacC(ijk, 24, 67) = + 0.4000000000000000D+00*dw(ijk,201, 67)
      JacC(ijk, 59, 67) =  - dw(ijk,201, 67)
      JacC(ijk, 67, 59) =  - dw(ijk,201, 59)
      JacC(ijk, 37, 67) =  + dw(ijk,202, 67) &
                           + dw(ijk,203, 67)
      JacC(ijk, 64, 67) =  - dw(ijk,202, 67)
      JacC(ijk, 67, 64) =  - dw(ijk,202, 64)
      JacC(ijk, 65, 67) =  - dw(ijk,203, 67)
      JacC(ijk, 67, 65) =  - dw(ijk,203, 65)
      JacC(ijk, 66, 67) =  - dw(ijk,204, 67)
      JacC(ijk, 67, 66) =  - dw(ijk,204, 66)
      JacC(ijk, 68, 67) =  - dw(ijk,206, 67)
      JacC(ijk, 34, 69) = + 0.1100000000000000D+00*dw(ijk,207, 69)
      JacC(ijk, 48, 69) = + 0.5000000000000000D+00*dw(ijk,207, 69)
      JacC(ijk, 69, 67) =  - dw(ijk,207, 67)
      JacC(ijk, 41, 67) =  + dw(ijk,208, 67) &
                          + 0.4840000000000000D+00*dw(ijk,209, 67)
      JacC(ijk, 48, 70) = + 0.5000000000000000D+00*dw(ijk,208, 70)
      JacC(ijk, 67, 70) =  - dw(ijk,208, 70)
      JacC(ijk, 70, 67) =  - dw(ijk,208, 67)
      JacC(ijk, 48, 71) = + 0.4840000000000000D+00*dw(ijk,209, 71)
      JacC(ijk, 67, 71) =  - dw(ijk,209, 71)
      JacC(ijk, 71, 67) =  - dw(ijk,209, 67)
      JacC(ijk, 33, 70) = + 0.6400000000000000D+00*dw(ijk,211, 70)
      JacC(ijk, 34, 70) = + 0.1490000000000000D+00*dw(ijk,211, 70)
      JacC(ijk, 70, 71) =  - dw(ijk,211, 71)
      JacC(ijk, 71, 70) =  - dw(ijk,211, 70)
      JacC(ijk,  5, 49) =  - dw(ijk,213, 49)
      JacC(ijk, 49,  5) =  - dw(ijk,213,  5) &
                          + 0.1550000000000000D+00*dw(ijk,215,  5) &
                          + 0.4000000000000000D-01*dw(ijk,216,  5) &
                           + dw(ijk,227,  5)
      JacC(ijk,  5, 50) =  - dw(ijk,214, 50)
      JacC(ijk, 50,  5) =  - dw(ijk,214,  5) &
                          + 0.5300000000000000D-01*dw(ijk,215,  5) &
                          + 0.2620000000000000D+00*dw(ijk,216,  5) &
                          + 0.1550000000000000D+00*dw(ijk,217,  5)
      JacC(ijk,  5, 51) =  - dw(ijk,215, 51)
      JacC(ijk, 51,  5) =  - dw(ijk,215,  5)
      JacC(ijk,  5, 52) =  - dw(ijk,216, 52)
      JacC(ijk, 52,  5) =  - dw(ijk,216,  5)
      JacC(ijk,  5, 53) =  - dw(ijk,217, 53)
      JacC(ijk, 53,  5) =  - dw(ijk,217,  5)
      JacC(ijk,  5, 54) =  - dw(ijk,218, 54)
      JacC(ijk, 54,  5) =  - dw(ijk,218,  5)
      JacC(ijk,  5, 55) =  - dw(ijk,219, 55)
      JacC(ijk, 55,  5) =  - dw(ijk,219,  5)
      JacC(ijk,  5, 56) =  - dw(ijk,220, 56)
      JacC(ijk, 56,  5) =  - dw(ijk,220,  5)
      JacC(ijk,  5, 57) =  - dw(ijk,221, 57)
      JacC(ijk, 57,  5) =  - dw(ijk,221,  5)
      JacC(ijk,  5, 58) =  - dw(ijk,222, 58)
      JacC(ijk, 58,  5) =  - dw(ijk,222,  5)
      JacC(ijk,  5, 59) =  - dw(ijk,223, 59)
      JacC(ijk, 59,  5) =  - dw(ijk,223,  5)
      JacC(ijk,  5, 64) =  - dw(ijk,224, 64)
      JacC(ijk, 64,  5) =  - dw(ijk,224,  5)
      JacC(ijk,  5, 65) =  - dw(ijk,225, 65)
      JacC(ijk, 65,  5) =  - dw(ijk,225,  5)
      JacC(ijk,  5, 66) =  - dw(ijk,226, 66)
      JacC(ijk, 66,  5) =  - dw(ijk,226,  5)
      JacC(ijk,  5, 67) =  - dw(ijk,227, 67)
      JacC(ijk,  5, 68) =  - dw(ijk,228, 68)
      JacC(ijk,  5, 69) =  - dw(ijk,229, 69)
      JacC(ijk, 69,  5) =  - dw(ijk,229,  5)
      JacC(ijk,  5, 70) =  - dw(ijk,230, 70)
      JacC(ijk,  5, 71) =  - dw(ijk,231, 71)
      JacC(ijk, 16, 72) =  - dw(ijk,232, 72) &
                           + dw(ijk,233, 72)
      JacC(ijk, 45, 72) =  + dw(ijk,232, 72)
      JacC(ijk, 72, 72) =  - dw(ijk,232, 72) &
                           - dw(ijk,233, 72) &
                           - dw(ijk,234, 72) &
                          - 0.2000000000000000D+01*dw(ijk,235, 72) &
                          - 0.2000000000000000D+01*dw(ijk,235, 72) &
                           - dw(ijk,236, 72) &
                           - dw(ijk,237, 72)
      JacC(ijk, 72, 16) =  - dw(ijk,232, 16)
      JacC(ijk, 32, 72) =  + dw(ijk,233, 72)
      JacC(ijk, 49, 72) =  - dw(ijk,233, 72) &
                           + dw(ijk,234, 72)
      JacC(ijk, 67, 72) =  - dw(ijk,234, 72)
      JacC(ijk,  3, 72) =  - dw(ijk,236, 72)
      JacC(ijk,  4, 72) =  + dw(ijk,236, 72) &
                           + dw(ijk,237, 72)
      JacC(ijk,  5, 72) =  - dw(ijk,237, 72)
       END DO                                                                                                                                         
                                                                                                                                                      
   END SUBROUTINE jacdchemdc                                                                                                                          
                                                                                                                                                      
  END MODULE mod_chem_spack_jacdchemdc                                                                                                                
                                                                                                                                                      
